function setActiveStyleSheet( id ) {
	
	var $ = jQuery;
	if( !$( '#style-selector .stylesheet-'+id ).get(0) ){
		var convert = {'lightblue':'37c6f5','blue':'3183d7','green':'3fc35f','cyan':'35d3b7','orange':'ff6e41','pink':'fa3aab','purple':'c762cb','bridge':'a5d549','slate':'6b798f','yellow':'f2d438','darkred':'970001'};
		$( '#style-selector' ).append('<link rel="stylesheet" type="text/css" onload="this.disabled=false;" class="stylesheet stylesheet-'+id+'" href="'+site_uri+'/?mode=css-color-style&color=%23'+convert[id]+'" title="'+id+'" disabled />');
	}
	$( '#style-selector .stylesheet' ).each(function(){
		if( $(this).hasClass('stylesheet-'+id) ){
			this.disabled = false;
		}else{
			this.disabled = true;
		}
	});

}

function getActiveStyleSheet() {
  var i, a;
  for(i=0; (a = document.getElementById('style-selector').getElementsByTagName("link")[i]); i++) {
    if(a.getAttribute("rel").indexOf("style") != -1 && a.getAttribute("title") && !a.disabled) return a.getAttribute("title");
  }
  return null;
}

function createCookie(name,value,days) {
  if (days) {
    var date = new Date();
    date.setTime(date.getTime()+(days*24*60*60*1000));
    var expires = "; expires="+date.toGMTString();
  }
  else expires = "";
  document.cookie = name+"="+value+expires+"; path=/";
}

function readCookie(name) {
  var nameEQ = name + "=";
  var ca = document.cookie.split(';');
  for(var i=0;i < ca.length;i++) {
    var c = ca[i];
    while (c.charAt(0)==' ') c = c.substring(1,c.length);
    if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
  }
  return null;
}


window.onunload = function(e) {

	var style = '';
	var i, a;
	for(i=0; (a = document.getElementById('style-selector').getElementsByTagName("link")[i]); i++) {
		if(a.getAttribute("rel").indexOf("style") != -1 && a.getAttribute("title") && a.disabled == false ) {
			style = a.getAttribute("title");
		}
	}

	createCookie("style", style, 365);

}

jQuery(document).ready(function($){  

	$('#style-selector').animate({left: -240});
	$('#switcher-style-button').click(function(e){
	  if( $('#style-selector').css('left') == '0px' ){
		  $('#style-selector').animate({left: -240});
	  }else{
		  $('#style-selector').animate({left: 0});
	  }
	  e.preventDefault();
	});
	
	$('#list-style-colors a').click(function(e){
		var title = $(this).attr('title').toLowerCase().replace(/ /g,'');
		setActiveStyleSheet( title );
		createCookie("style", title, 365);
		e.preventDefault();
		$(this).find('span').append('<i class="fa fa-spinner fa-pulse fa-fw"></i>');
		$('header .logo img,.navbar-header .logo img').attr({'src':'http://business-theme.com/preview/aloom/attachments/logos/logo-'+title+'.png'});
		var elm = $(this).find('span');
		setTimeout(function(){
			elm.html('');
		}, 1000);
	});
	
	$('#style-switcher-bg li span').click(function(e){
		var bg = $(this).css('background-image');
		bg = bg.replace('-small.jpg', '.jpg');
		$('body').css({'background-image' : bg });
		createCookie("bg", bg, 365);
		e.preventDefault();
		$(this).append('<i class="fa fa-spinner fa-pulse fa-fw"></i>');
		var elm = $(this);
		setTimeout(function(){
			elm.html('');
		}, 1000);
	});
	
  	var style = readCookie("style");
  	var bg = readCookie("bg");
	if( style ){
		setActiveStyleSheet(style);
		$('header .logo img,.navbar-header .logo img').attr({'src':'http://business-theme.com/preview/aloom/attachments/logos/logo-'+style+'.png'});
	}
	if( bg ){
		$('body').css({'background-image' : bg });
	}

});



