<?php
/*
*	This is private registration with WP
* 	(c) king-theme.com
*	
*/

global $king;

add_action( "wp_head", 'king_meta', 0 ); 
add_action( "get_header", 'king_set_header' ); 
add_action( "wp_head", 'king_custom_header' );
add_action( "wp_footer", 'king_custom_footer' );


function king_set_header( $name ){
	
	global $king;
	
	if( !empty( $name ) ){
		$file = ( strpos( $name, '.php' ) === false ) ? $name.'.php' : $name;
		if( file_exists( THEME_PATH.DS.'templates/header/'.$file ) ){	
			$king->cfg[ 'header' ] = $file;
			$king->cfg[ 'header_autoLoaded' ] = 1;
		}	
	}

}

/*-----------------------------------------------------------------------------------*/
# Setup custom header from theme panel
/*-----------------------------------------------------------------------------------*/

function king_custom_header(){		
	
	echo '<script type="text/javascript">var site_uri = "'.SITE_URI.'";var theme_uri = "'.THEME_URI.'";</script>';
		
	$options_css = get_option( 'king_'.strtolower( THEME_NAME ).'_options_css', true ); 
	if( !empty( $options_css ) ){
		echo '<style type="text/css">/**THEME OPTION**/';
		echo str_replace( array( '%HOME_URL%', '<style', '</style>' ), array( HOME_URL, '&lt;', '' ), $options_css );
		if( is_admin_bar_showing() ){
			echo '.header{margin-top:32px;}';
		}
		echo '</style>';
	}
}

/*-----------------------------------------------------------------------------------*/
# setup footer from theme panel
/*-----------------------------------------------------------------------------------*/


function king_custom_footer( ){
		
	echo '<a href="#" class="scrollup" id="scrollup" style="display: none;">Scroll</a>'."\n";
	
}


/* Add box select layouts into page|post editting */
add_action('save_post','king_save_page_layout_template',10,2);
function king_save_page_layout_template( $post_id, $post ) {

	if( $post->post_type == 'our-team' ){
	
		$position = !empty($_POST['king_staff_position']) ? $_POST['king_staff_position'] : '';
		$facebook = !empty($_POST['king_staff_facebook']) ? $_POST['king_staff_facebook'] : '';
		$twitter = !empty($_POST['king_staff_twitter']) ? $_POST['king_staff_twitter'] : '';
		$gplus = !empty($_POST['king_staff_gplus']) ? $_POST['king_staff_gplus'] : '';
		$linkedin = !empty($_POST['king_staff_linkedin']) ? $_POST['king_staff_linkedin'] : '';
		$skype = !empty($_POST['king_staff_skype']) ? $_POST['king_staff_skype'] : '';
		
		if( !update_post_meta( $post->ID , 'king_staff' , array( 'position' => $position, 'facebook' => $facebook , 'twitter' => $twitter, 'gplus' => $gplus, 'linkedin' => $linkedin ) ) ){
			add_post_meta( $post->ID , 'king_staff' , array( 'position' => $position, 'facebook' => $facebook , 'twitter' => $twitter, 'gplus' => $gplus, 'linkedin' => $linkedin ) );
		}	
	}

		
	if( $post->post_type == 'our-works' ){
		$link = !empty($_POST['king_project_link']) ? $_POST['king_project_link'] : '';
		if( !update_post_meta( $post->ID , 'king_work' , $link ) ){
			add_post_meta( $post->ID , 'king_work' , $link );	
		}	
	}	
	
	if( $post->post_type == 'testimonials' ){
		$link = !empty($_POST['king_testi_website']) ? $_POST['king_testi_website'] : '';
		$rate = !empty($_POST['king_testi_rate']) ? $_POST['king_testi_rate'] : '';
		if( !update_post_meta( $post->ID , 'king_testi' , array( 'website' => $link, 'rate' => $rate ) ) ){
			add_post_meta( $post->ID , 'king_testi' , array( 'website' => $link, 'rate' => $rate ) );	
		}
	}	
	
	if( $post->post_type == 'pricing-tables' ){
		
		$priceData = array( 
			'price'		=> !empty($_POST['king_pricing_price'])?$_POST['king_pricing_price']:'',
			'per'		=> !empty($_POST['king_pricing_per'])?$_POST['king_pricing_per']:'',
			'attr'		=> !empty($_POST['king_pricing_attributes'])?$_POST['king_pricing_attributes']:'',
			'textsubmit'	=> !empty($_POST['king_pricing_textsubmit'])?$_POST['king_pricing_textsubmit']:'',
			'linksubmit'	=> !empty($_POST['king_pricing_submitlink'])?$_POST['king_pricing_submitlink']:'',
			'textsubmit2'	=> !empty($_POST['king_pricing_textsubmit2'])?$_POST['king_pricing_textsubmit2']:'',
			'linksubmit2'	=> !empty($_POST['king_pricing_submitlink2'])?$_POST['king_pricing_submitlink2']:'',
			'subtext'	=> !empty($_POST['king_pricing_subtext'])?$_POST['king_pricing_subtext']:'',

		);	
		
		if( !update_post_meta( $post->ID , 'king_pricing' , $priceData ) ){
			add_post_meta( $post->ID , 'king_pricing' , $priceData );
		}
		
	}
	
	if( $post->post_type == 'page' && !empty( $_POST['king'] ) ){
	
		if( !empty( $_POST['king']['header'] ) ){
			if( update_post_meta( $post->ID, '_king_page_header', $_POST['king']['header'] ) ){
				add_post_meta( $post->ID, '_king_page_header', $_POST['king']['header'] );
			}	
		}		
		if( !empty( $_POST['king']['footer'] ) ){
			if( update_post_meta( $post->ID, '_king_page_footer', $_POST['king']['footer'] ) ){
				add_post_meta( $post->ID, '_king_page_footer', $_POST['king']['footer'] );
			}
		}		
		if( !empty( $_POST['king']['breadcrumb'] ) ){
			if( update_post_meta( $post->ID, '_king_page_breadcrumb', $_POST['king']['breadcrumb'] ) ){
				add_post_meta( $post->ID, '_king_page_breadcrumb', $_POST['king']['breadcrumb'] );
			}	
		}
		if( empty( $_POST['king']['breadcrumb_bg'] ) ){
			$_POST['king']['breadcrumb_bg'] = '';
		}
		if( update_post_meta( $post->ID, '_king_page_breadcrumb_bg', $_POST['king']['breadcrumb_bg'] ) ){
			add_post_meta( $post->ID, '_king_page_breadcrumb_bg', $_POST['king']['breadcrumb_bg'] );
		}
		if( !empty( $_POST['king']['page_title'] ) ){
			if( update_post_meta( $post->ID, '_king_page_page_title', $_POST['king']['page_title'] ) ){
				add_post_meta( $post->ID, '_king_page_page_title', $_POST['king']['page_title'] );
			}	
		}else{
			delete_post_meta( $post->ID, '_king_page_page_title' );
		}
		if( !empty( $_POST['king']['description'] ) ){
			if( update_post_meta( $post->ID, '_king_page_description', $_POST['king']['description'] ) ){
				add_post_meta( $post->ID, '_king_page_description', $_POST['king']['description'] );
			}	
		}else{
			delete_post_meta( $post->ID, '_king_page_description' );
		}
		if( !empty( $_POST['king']['sidebar'] ) ){
			if( update_post_meta( $post->ID, '_king_page_sidebar', $_POST['king']['sidebar'] ) ){
				add_post_meta( $post->ID, '_king_page_sidebar', $_POST['king']['sidebar'] );
			}	
		}else{
			delete_post_meta( $post->ID, '_king_page_sidebar' );
		}		
		if( empty( $_POST['king']['logo'] ) ){
			$_POST['king']['logo'] = '';
		}
		if( update_post_meta( $post->ID, '_king_page_logo', $_POST['king']['logo'] ) ){
			add_post_meta( $post->ID, '_king_page_logo', $_POST['king']['logo'] );
		}
		if( empty( $_POST['king']['modal'] ) ){
			$_POST['king']['modal'] = '';
		}
		if( update_post_meta( $post->ID, '_king_page_modal', $_POST['king']['modal'] ) ){
			add_post_meta( $post->ID, '_king_page_modal', $_POST['king']['modal'] );
		}
	}

}

function king_post_save_regexp($m){
		
	return str_replace('"',"'",$m[0]);
	
}

add_action("after_switch_theme", "king_activeTheme", 1000 ,  1);
/*----------------------------------------------------------*/
#	Active theme -> import some data
/*----------------------------------------------------------*/
function king_activeTheme( $oldname, $oldtheme=false ) {
 	
 	global $king;
	#Check to import base of settings
	get_template_part( 'core/import' );
	
	# Make sure all images & icons are readable
	king_check_filesReadable( ABSPATH.'wp-content'.DS.'themes'.DS.$king->stylesheet );
	
	if( $king->template == $king->stylesheet ){
		
		?>
		<style type="text/css">
			body{display:none;}
		</style>
		<script type="text/javascript">
			/*Redirect to install required plugins after active theme*/
			window.location = '<?php echo esc_url( 'admin.php?page='.strtolower( THEME_NAME ).'-importer' ); ?>';
		</script>
		
		<?php	
	
	}
}

/*-----------------------------------------------------------------------------------*/
# 	Check un-readable files, and change chmod to readable
/*-----------------------------------------------------------------------------------*/

function king_check_filesReadable( $dir = '' ){

	if( $dir != '' && is_dir( $dir ) ){
		
		if ( $handle = opendir( $dir ) ){
			
			@chmod( $dir, 0755 );
			
			while ( false !== ( $entry = readdir($handle) ) ) {
				if( $entry != '.' && $entry != '..' && strpos($entry, '.php') === false && is_file( $dir.DS.$entry ) ){
					
					$perm = substr(sprintf('%o', fileperms( $dir.DS.$entry )), -1 );

					if( $perm == '0' ){
						@chmod( $dir.DS.$entry, 0644 );
					}	
				}
				if( $entry != '.' && $entry != '..' && is_dir( $dir.DS.$entry ) ){
					king_check_filesReadable( $dir.DS.$entry );
				}
			}
		}
		
	}
}

/*-----------------------------------------------------------------------------------*/
# 	Register Menus in NAV-ADMIN
/*-----------------------------------------------------------------------------------*/


add_action('admin_menu', 'king_settings_menu');
function king_settings_menu() {

	// Menu hook
	global $king_hook,$king;

	$cap = 'manage_options';
	$icon = 'dashicons-analytics'; 
	$update = '';

	// Add main page
	$king_hook = $king->ext['amp'](
		THEME_NAME.' Theme Panel', THEME_NAME.' Theme Panel', $cap, strtolower( THEME_NAME ).'-panel', 'king_router', $icon, 10001
	);
	
	$king->ext['asmp'](
		strtolower( THEME_NAME ).'-panel', 'Import Sample Data', __('Import Demos', 'aloom'), $cap, strtolower( THEME_NAME ).'-importer', 'king_router'
	);
	
		
}


function king_router() {
	
	global $king, $king_options;
	switch( $king->page ){

		case strtolower( THEME_NAME ).'-panel':
			$king->assets(array(
				array('js' => THEME_URI.'/core/assets/jscolor/jscolor')
			));
			$king_options->_options_page_html();
			
		break;
		case strtolower( THEME_NAME ).'-importer':
		
			$king->assets(array(
				array('css' => THEME_URI.'/core/assets/css/bootstrap.min'),
				array('css' => THEME_URI.'/options/css/theme-pages')
			));
			get_template_part( 'core/sample' );
			
		break;	
		
	}	

}

add_action('add_meta_boxes','king_add_page_layout_template_metabox');
/*----------------------------------------------------------*/
#	Add select layout on page edit
/*----------------------------------------------------------*/
function king_add_page_layout_template_metabox() {
	add_meta_box('devnselectpath', THEME_NAME.' Theme - Page Settings', 'king_page_fields_meta_box', 'page', 'normal', 'core');
    add_meta_box('devnfeildstesti', __('Testimonial Options','aloom'), 'king_testi_fields_meta_box', 'testimonials', 'normal', 'high');
    add_meta_box('devnfeildsteam', __('Staff Profiles','aloom'), 'king_staff_fields_meta_box', 'our-team', 'normal', 'high');
    add_meta_box('devnfeildswork', __('Project\'s Link','aloom'), 'king_work_fields_meta_box', 'our-works', 'normal', 'high');
    add_meta_box('devnfeildspricing', __('Pricing Tables Fields','aloom'), 'king_pricing_fields_meta_box', 'pricing-tables', 'normal', 'high');
}

function king_page_fields_meta_box( $post ){
	
	global $king, $king_options;
	
	locate_template( 'options/options.php', true );
	
	$header = get_post_meta( $post->ID,'_king_page_header' , true );
	$footer = get_post_meta( $post->ID,'_king_page_footer' , true );
	$logo = get_post_meta( $post->ID,'_king_page_logo' , true );
	$modal = get_post_meta( $post->ID,'_king_page_modal' , true );
	$breadcrumb = get_post_meta( $post->ID,'_king_page_breadcrumb' , true );
	$description = get_post_meta( $post->ID,'_king_page_description' , true );
	$sidebar = get_post_meta( $post->ID,'_king_page_sidebar' , true );
	$breadcrumb_bg = get_post_meta( $post->ID,'_king_page_breadcrumb_bg' , true );
	$page_title = get_post_meta( $post->ID,'_king_page_page_title' , true );
	
	if( empty( $header ) ){
		$header = 'default';
	}
	if( empty( $footer ) ){
		$footer = 'default';
	}
	if( empty( $breadcrumb ) ){
		$breadcrumb = 'global';
	}
	
	$listHeaders = array();
	if ( $handle = opendir( THEME_PATH.DS.'templates'.DS.'header' ) ){
		
		$listHeaders[ 'default' ] = array('title' => '.Use Global Setting', 'img' => THEME_URI.'/core/assets/images/load-default.jpg' );
		
		while ( false !== ( $entry = readdir($handle) ) ) {
			if( $entry != '.' && $entry != '..' && strpos($entry, '.php') !== false  ){
				$title  = ucwords( str_replace( '-', ' ', basename( $entry, '.php' ) ) );
				$listHeaders[ $entry ] = array('title' => $title, 'img' => THEME_URI.'/templates/header/thumbnails/'.basename( $entry, '.php' ).'.jpg' );
			}
		}
	}
	
	$listFooters = array();
	if ( $handle = opendir( THEME_PATH.DS.'templates'.DS.'footer' ) ){
		$listFooters[ 'default' ] = array('title' => '.Use Global Setting', 'img' => THEME_URI.'/core/assets/images/load-default.jpg' );
		while ( false !== ( $entry = readdir($handle) ) ) {
			if( $entry != '.' && $entry != '..' && strpos($entry, '.php') !== false  ){
				$title  = ucwords( str_replace( '-', ' ', basename( $entry, '.php' ) ) );
				$listFooters[ $entry ] = array('title' => $title, 'img' => THEME_URI.'/templates/footer/thumbnails/'.basename( $entry, '.php' ).'.jpg' );
			}
		}
	}

	$sidebars = array( '' => '--Select Sidebar--' );
	
	if( !empty( $king->cfg['sidebars'] ) ){
		foreach( $king->cfg['sidebars'] as $sb ){
			$sidebars[ sanitize_title_with_dashes( $sb ) ] = esc_html( $sb );
		}
	}
	
	$fields = array(
		array(
			'id' => 'logo',
			'type' => 'upload',
			'title' => __('Upload Logo', 'aloom'), 
			'sub_desc' => __('This will be display as logo at header of only this page', 'aloom'),
			'desc' => __('Upload new or from media library to use as your logo. We recommend that you use images without borders and throughout.', 'aloom'),
			'std' => $logo
		),		
		array(
			'id' => 'modal',
			'type' => 'upload',
			'title' => __('Upload Image Modal', 'aloom'), 
			'sub_desc' => __('Image to show on Modal Window', 'aloom'),
			'std' => $modal
		),
		array(
			'id' => 'breadcrumb',
			'type' => 'select',
			'title' => __('Display Breadcrumb', 'aloom'), 
			'options' => array( 
				'global' => 'Use Global Settings', 
				'page_title' => 'Yes, Please!',
				'no' => 'No, Thanks!',
				'page_title2' => 'Page Title 2', 
				'page_title2 sty3' => 'Page Title 2 style 3', 
				'page_title2 sty4' => 'Page Title 2 style 4',
				'page_title2 sty5' => 'Page Title 2 style 5', 
				'page_title2 sty6' => 'Page Title 2 style 6', 
				'page_title2 sty7' => 'Page Title 2 style 7', 
				'page_title2 sty8' => 'Page Title 2 style 8', 
				'page_title2 sty9' => 'Page Title 2 style 9', 
				'page_title2 sty10' => 'Page Title 2 style 10', 
				'page_title3' => 'Page Title 3', 
				'page_title3 sty2' => 'Page Title 3 style 2',
				'page_title3 sty3' => 'Page Title 3 style 3',
				'page_title3 sty4' => 'Page Title 3 style 4',
			),
			'std' => $breadcrumb,
			'sub_desc' => 'Set for show or dont show breadcrumb for only this page.'
		),
		array(
			'id' => 'breadcrumb_bg',
			'type' => 'upload',
			'title' => __('Upload Breadcrumb Background Image', 'aloom'), 
			'std' => $breadcrumb_bg,
			'sub_desc' => __( 'Upload your Breadcrumb background image for this page.', 'aloom' )
		),
		array(
			'id' => 'page_title',
			'type' => 'textarea',
			'title' => __('Page Title', 'aloom'),
			'std'	=> $page_title,
			'sub_desc' => __( 'Page Title will display on Breadcrumn instead default title.', 'aloom' ),
			'desc' => ''
		),		
		array(
			'id' => 'sidebar',
			'type' => 'select',
			'title' => __('Select Sidebar', 'aloom'), 
			'options' => $sidebars,
			'std' => $sidebar,
			'sub_desc' => 'Select template from Page Attributes at right side',
			'desc' => '<br /><br />Select a dynamic sidebar what you created in theme-panel to display under page layout.'
		),
		array(
			'id' => 'description',
			'type' => 'textarea',
			'title' => __('Description', 'aloom'),
			'std'	=> $description,
			'sub_desc' => 'The description will show in content of meta tag for SEO + Sharing purpose',
		),
		array(
			'id' => 'header',
			'type' => 'radio_img',
			'title' => __('Select Header', 'aloom'),
			'sub_desc' => __('Overlap: The header will cover up anything beneath it.', 'aloom'),
			'options' => $listHeaders,
			'std' => $header
		),
		array(
			'id' => 'footer',
			'type' => 'radio_img',
			'title' => __('Select Footer', 'aloom'),
			'sub_desc' => __('Select footer to display for only this page. This path has located /templates/footer/__file__', 'aloom'),
			'options' => $listFooters,
			'std' => $footer
		)
	);
	
	echo '<div class="nhp-opts-group-tab single-page-settings" style="display:block;padding:0px;">';
	echo '<table class="form-table" style="display:inline-block;border:none;"><tbody>';
	foreach( $fields as $key => $field ){
		
		locate_template( 'options/fields/'.$field['type'].'/field_'.$field['type'].'.php', true );
		
		$field_class = 'king_options_'.$field['type'];
		if(class_exists($field_class)){
			$render = '';
			$obj = new stdClass();
			$obj->extra_tabs = '';
			$obj->sections = '';
			$obj->args = '';
			$render = new $field_class($field, $field['std'], $obj );
			echo '<tr><th scope="row">'.esc_html($field['title']).'<span class="description">';
			echo esc_html($field['sub_desc']).'</span></th>';
			echo '<td>';
			$render->render();
			if( method_exists( $render, 'enqueue' ) ){
				$render->enqueue();
			}	
			echo '</td></tr>';
		}
	}
	echo '</tbody></table></div>';
	
}

function king_testi_fields_meta_box( $post ) {

	$testi = get_post_meta( $post->ID , 'king_testi' );
	if( !empty( $testi ) ){
		$testi  = $testi[0];
	}else{
		$testi = array( 'website' => '', 'rate' => '');
	}	
	
?>

	<table>
		<tr>
			<td>
				<label><?php _e('Website','aloom'); ?>: </label>
			</td>
			<td>	
				<input type="text" name="king_testi_website" value="<?php echo esc_attr( $testi['website'] );	?>" />
			</td>
		</tr>
		<tr>
			<td>
				<br />
				<label><?php _e('Rate','aloom'); ?>: </label>
			</td>
			<td>
				<br />
				<i class="fa fa-star"></i> 
				<input type="radio" name="king_testi_rate" <?php if($testi['rate']==1)echo 'checked'; ?> value="1" />
				&nbsp; 
				<i class="fa fa-star"></i><i class="fa fa-star"></i> <input type="radio" <?php if($testi['rate']==2)echo 'checked'; ?> name="king_testi_rate" value="2" />
				&nbsp; 
				<i class="fa fa-star"></i><i class="fa fa-star"></i><i class="fa fa-star"></i> 
				<input type="radio" name="king_testi_rate" <?php if($testi['rate']==3)echo 'checked'; ?> value="3" />
				&nbsp; 
				<i class="fa fa-star"></i><i class="fa fa-star"></i><i class="fa fa-star"></i><i class="fa fa-star"></i>
				<input type="radio" name="king_testi_rate" <?php if($testi['rate']==4)echo 'checked'; ?> value="4" />
				&nbsp; 
				<i class="fa fa-star"></i><i class="fa fa-star"></i><i class="fa fa-star"></i><i class="fa fa-star"></i><i class="fa fa-star"></i> 
				<input type="radio" name="king_testi_rate" <?php if($testi['rate']==5)echo 'checked'; ?> value="5" />
			</td>
		</tr>
	</table>

<?php
}

function king_staff_fields_meta_box( $post ) {

	$staff = get_post_meta( $post->ID , 'king_staff' );
	if( !empty( $staff ) ){
		$staff  = $staff[0];
	}else{
		$staff = array( 'position' => '', 'facebook' => '', 'twitter' => '', 'gplus' => '', 'linkedin' => '' );
	}	
	
?>

	<table>
		<tr>
			<td>
				<label><?php _e('Position','aloom'); ?>: </label>
			</td>
			<td>	
				<input type="text" name="king_staff_position" value="<?php echo esc_attr( $staff['position'] );	?>" />
			</td>
		</tr>
		<tr>
			<td>
				<label><?php _e('Facebook','aloom'); ?>: </label>
			</td>
			<td>
				<input type="text" name="king_staff_facebook" value="<?php echo esc_attr( $staff['facebook'] );	?>" />
			</td>
		</tr>
		<tr>
			<td>
				<label><?php _e('Twitter','aloom'); ?>: </label>
			</td>
			<td>
				<input type="text" name="king_staff_twitter" value="<?php echo esc_attr( $staff['twitter'] );	?>" />
			</td>
		</tr>
		<tr>
			<td>
				<label><?php _e('Google+','aloom'); ?>: </label>
			</td>
			<td>
				<input type="text" name="king_staff_gplus" value="<?php echo esc_attr( $staff['gplus'] );	?>" />
			</td>
		</tr>
		<tr>
			<td>
				<label><?php _e('LinkedIn','aloom'); ?>: </label>
			</td>
			<td>
				<input type="text" name="king_staff_linkedin" value="<?php echo esc_attr( isset($staff['linkedin'])?$staff['linkedin']:'' );	?>" />
			</td>
		</tr>
	</table>

<?php
}


function king_work_fields_meta_box( $post ) {

	$work = get_post_meta( $post->ID , 'king_work' );
	if( !empty( $work ) ){
		$work  = $work[0];
	}else{
		$work = '';
	}	
	
?>

	<input type="text" name="king_project_link" value="<?php echo esc_attr( $work ); ?>" style="width: 100%;" />

<?php
}



function king_pricing_fields_meta_box( $post ) {

	$pricing = get_post_meta( $post->ID , 'king_pricing' );
	if( !empty( $pricing ) ){
		$pricing  = $pricing[0];
	}else{
		$pricing = array( 'price' => '$100', 'per' => 'per month', 'trydes' => 'Making this the first true generator necessary on the Internet.', 'trytext' => 'Try Free for 30 Days', 'trylink' => '#', 'attr' => "Option 1\nOption 2", 'morelink' => '#', 'textsubmit' => 'Choose Plan', 'linksubmit' => '#', 'textsubmit2' => '', 'linksubmit2' => '', 'subtext' =>'' );
	}	
	
?>

	<table>
		<tr>
			<td>
				<label><?php _e('Price','aloom'); ?>: </label>
			</td>
			<td>	
				<input type="text" name="king_pricing_price" value="<?php echo esc_attr( $pricing['price'] );	?>" /> / 
				<input type="text" name="king_pricing_per" value="<?php echo esc_attr( $pricing['per'] );	?>" />
			</td>
		</tr>
		<tr>
			<td>
				<label><?php _e('Attributes','aloom'); ?>: </label>
			</td>
			<td>
				<textarea rows="8" cols="80" name="king_pricing_attributes"><?php echo esc_attr( $pricing['attr'] );	?></textarea>
			</td>
		</tr>
		<tr>
			<td>
				<label><?php _e('Text button submit','aloom'); ?>: </label>
			</td>
			<td>
				<input type="text" name="king_pricing_textsubmit" value="<?php echo esc_attr( $pricing['textsubmit'] );	?>" />
			</td>
		</tr>
		<tr>
			<td>
				<label><?php _e('Link submit','aloom'); ?>: </label>
			</td>
			<td>
				<input type="text" name="king_pricing_submitlink" value="<?php echo esc_attr( $pricing['linksubmit'] );	?>" />
			</td>
		</tr>
		<tr>
			<td colspan="2">
				<br><br>
				<strong><?php _e('Extra fields for layout 3','aloom'); ?></strong>
				<br>
			</td>
		</tr>		
		<tr>
			<td>
				<label><?php _e('Text button submit 2','aloom'); ?>: </label>
			</td>
			<td>
				<input type="text" name="king_pricing_textsubmit2" value="<?php echo esc_attr( $pricing['textsubmit2'] );	?>" />
			</td>
		</tr>
		<tr>
			<td>
				<label><?php _e('Link submit 2','aloom'); ?>: </label>
			</td>
			<td>
				<input type="text" name="king_pricing_submitlink2" value="<?php echo esc_attr( $pricing['linksubmit2'] );	?>" />
			</td>
		</tr>
		<tr>
			<td>
				<label><?php _e('Sub text','aloom'); ?>: </label>
			</td>
			<td>
				<textarea rows="4" cols="80" name="king_pricing_subtext"><?php echo esc_attr( $pricing['subtext'] );	?></textarea>
			</td>
		</tr>
	</table>
	

<?php
}


/*Add post type*/
add_action( 'init', 'king_init' );
function king_init() {

	global $king;
		
    if( is_admin() ){
   		$king->sysInOut();
   	}else{
   		if( !empty( $king->cfg['admin_bar'] ) ){
   			if( $king->cfg['admin_bar'] != 'show' ){
		   		show_admin_bar(false);
		   	}	
   		}
   	}	
}

/*Add Custom Sidebar*/
function king_widgets_init() {
		
	global $king;
	
	$sidebars = array(
		
		'sidebar' => array( 
			__( 'Main Sidebar', 'aloom' ), 
			__( 'Appears on posts and pages at left-side or right-side except the optional Front Page template.', 'aloom' )
		),
		
		'sidebar-woo' => array( 
			__( 'Archive Products Sidebar', 'aloom' ), 
			__( 'Appears on Archive Products.', 'aloom' )
		),	
		'sidebar-woo-single' => array( 
			__( 'Single Product Sidebar', 'aloom' ), 
			__( 'Appears on Single Product detail page', 'aloom' )
		),
						
		'footer_1' => array( 
			__( 'Footer Column 1', 'aloom' ), 
			__( 'Appears on column 1 at Footer', 'aloom' )
		),		
		
		'footer_2' => array( 
			__( 'Footer Column 2', 'aloom' ), 
			__( 'Appears on column 2 at Footer', 'aloom' )
		),		
		
		'footer_3' => array( 
			__( 'Footer Column 3', 'aloom' ), 
			__( 'Appears on column 3 at Footer', 'aloom' )
		),		
		
		'footer_4' => array( 
			__( 'Footer Column 4', 'aloom' ), 
			__( 'Appears on column 4 at Footer', 'aloom' )
		),
								
		'footer1_1' => array( 
			__( 'Footer 1 Column 1', 'aloom' ), 
			__( 'Appears on column 1 at Footer 1', 'aloom' )
		),		
		
		'footer1_2' => array( 
			__( 'Footer 1 Column 2', 'aloom' ), 
			__( 'Appears on column 2 at Footer 1', 'aloom' )
		),		
		
		'footer1_3' => array( 
			__( 'Footer 1 Column 3', 'aloom' ), 
			__( 'Appears on column 3 at Footer 1', 'aloom' )
		),
				
		'footer2' => array( 
			__( 'Footer 2', 'aloom' ), 
			__( 'Appears on Footer 2', 'aloom' )
		),
		
		'footer3' => array( 
			__( 'Footer 3', 'aloom' ), 
			__( 'Appears on Footer 3', 'aloom' )
		),
			
		'footer4_1' => array( 
			__( 'Footer 4 column 1', 'aloom' ), 
			__( 'Appears on column 1 at Footer 4', 'aloom' )
		),
		
		'footer4_2' => array( 
			__( 'Footer 4 Column 2', 'aloom' ), 
			__( 'Appears on column 2 at Footer 4', 'aloom' )
		),
				
		'footer4_3' => array( 
			__( 'Footer 4 column 3', 'aloom' ), 
			__( 'Appears on column 3 at Footer 4', 'aloom' )
		),
		
		'footer5_1' => array( 
			__( 'Footer 5 Column 1', 'aloom' ), 
			__( 'Appears on column 1 at Footer 3', 'aloom' )
		),
				
		'footer5_2' => array( 
			__( 'Footer 5 column 2', 'aloom' ), 
			__( 'Appears on column 2 at Footer 3', 'aloom' )
		),
		
		'footer5_3' => array( 
			__( 'Footer 5 Column 3', 'aloom' ), 
			__( 'Appears on column 3 at Footer 3', 'aloom' )
		),
				
		'footer5_4' => array( 
			__( 'Footer 5 column 4', 'aloom' ), 
			__( 'Appears on column 3 at Footer 3', 'aloom' )
		),
		
	);
	
	if( !empty( $king->cfg['sidebars'] ) ){
		foreach( $king->cfg['sidebars'] as $sb ){
			$sidebars[ sanitize_title_with_dashes( $sb ) ] = array(
				esc_html( $sb ), 
				__( 'Dynamic Sidebar - Manage via theme-panel', 'aloom' )
			);
		}
	}
	
	foreach( $sidebars as $k => $v ){
	
		register_sidebar( array(
			'name' => $v[0],
			'id' => $k,
			'description' => $v[1],
			'before_widget' => '<aside id="%1$s" class="widget %2$s">',
			'after_widget' => '</aside>',
			'before_title' => '<h3 class="widget-title"><span>',
			'after_title' => '</span></h3>',
		));	
		
	}
	
}
add_action( 'widgets_init', 'king_widgets_init' );


add_filter( 'image_size_names_choose', 'my_custom_sizes' );
function my_custom_sizes( $sizes ) {
    return array_merge( $sizes, array(
        'large-small' => __('Large Small', 'aloom'),
    ) );
}

add_filter( 'wp_nav_menu_items','king_mainnav_last_item', 10, 2 ); 
function king_mainnav_last_item( $items, $args ) {
	if( $args->theme_location == 'primary' ){
		
		global $king, $woocommerce;
		if( empty( $king->cfg['minicartNav'] ) ){
			$king->cfg['minicartNav'] = 'show';
		}
		if( empty( $king->cfg['searchNav'] ) ){
			$king->cfg['searchNav'] = 'show';
		}
		/*
		*	Display Minicart
		*/
		if( $king->cfg['minicartNav'] == 'show' && !empty($woocommerce) ){
		
			$items .= '<li class="dropdown yamm ext-nav minicart-nav">'.
						  '<a href="#"><i class="et-basket et"></i></a>'.
						  '<ul class="dropdown-menu">'.
						 	 '<li>';
						  
							if( function_exists( 'king_cart_func' ) ){
								$items .= '<div class="minicart-wrp">'.king_cart_func( array() ).'</div>';
							}
			
			$items .= 		'</li>'.
					  	'</ul>'.
					 '</li>'; 
		}	
		/*
		*	Display Search Box
		*/
		if( $king->cfg['searchNav'] == 'show' ){
			$items .= '<li class="dropdown yamm ext-nav search-nav">'.
						  '<a href="#"><i class="icon icon-magnifier"></i></a>'.
						  '<ul class="dropdown-menu">'.
						  '<li>'.get_search_form( false ).'</li>'.
						  '</ul>'.
					  '</li>'; 
		}	
		
	}
	return $items; 
}

/*-----------------------------------------------------------------------------------*/
# Load layout from system before theme loads
/*-----------------------------------------------------------------------------------*/

function king_load_layout( $file ){
	
	global $king, $post;
	
	if( is_home() ){
	
		$cfg = ''; $_file = '';
	
		if( !empty( $king->cfg['blog_layout'] ) ){
			$cfg = $king->cfg['blog_layout'];
		}
		
		if( file_exists( THEME_PATH.DS.'templates'.DS.'blog-'.$cfg.'.php' ) ){
			$_file =  'templates'.DS.'blog-'.$cfg.'.php';
		}
		
		if( get_option('show_on_front',true) == 'page' && $_file === '' ){
			$id = get_option('page_for_posts',true);
			if( !empty( $id ) ){
				$get_page_tem = get_page_template_slug( $id );
			    if( !empty( $get_page_tem ) ){
					$_file = $get_page_tem;
				}	
			}
		}
	
		if( !empty( $_GET['layout'] ) ){
			if( file_exists( THEME_PATH.DS.'templates'.DS.'blog-'.$_GET['layout'].'.php' ) ){
				$_file = 'templates'.DS.'blog-'.$_GET['layout'].'.php';
			}	
		}
		
		if( !empty( $_file ) ){
			return locate_template( $_file );
		}
	}
	
	if( $king->vars( 'action', 'login' ) ){
		return locate_template( 'templates'.DS.'king.login.php' );
	}
	if( $king->vars( 'action', 'register' ) ){
		return locate_template( 'templates'.DS.'king.register.php' );
	}
	if( $king->vars( 'action', 'forgot' ) ){
		return locate_template( 'templates'.DS.'king.forgot.php' );
	}
	
	$king->tp_mode( basename( $file, '.php' ) );
	
	return $file;

}
add_action( "template_include", 'king_load_layout', 99 );

function king_exclude_category( $query ) {
    if ( $query->is_home() && $query->is_main_query() ) {
    	global $king;
    	if( !empty( $king->cfg['timeline_categories'] ) ){
	    	if( $king->cfg['timeline_categories'][0] != 'default' ){
		    	 $query->set( 'cat', implode( ',', $king->cfg['timeline_categories'] ) );	
	    	}
    	}
    }
}
add_action( 'pre_get_posts', 'king_exclude_category' );

function king_admin_notice() {
	if ( get_option('permalink_structure', true) === false ) {
    ?>
    <div class="updated">
        <p>You have not yet enabled permalink, the 404 page and some functions will not work. To enable, please <a href="<?php echo SITE_URI; ?>/wp-admin/options-permalink.php">Click here</a> and choose "Post name"</p>
    </div>
    <?php
    }
}
add_action( 'admin_notices', 'king_admin_notice' );