<?php

class king_elements {

	public static function icon( $atts ){
		
		$image = $atts['image'];
		if((int)$image > 0 && ($image_url = wp_get_attachment_url( $image, 'thumbnail' )) !== false) {
	        // some stuff
	    }else{
		    $image_url = THEME_URI.'/assets/images/default.png';
	    }
	    if( $image_url != THEME_URI.'/assets/images/default.png' ){
    		echo '<img src="'.esc_url( $image_url ).'" class="element-icon '.esc_attr( $atts['icon_class'] ).'" alt=""/>';
		}else if( strpos( $atts['icon_awesome'], 'empty' ) === false ){
    		echo '<i class="fa fa-'.esc_attr( $atts['icon_awesome'] ).' element-icon '.esc_attr( $atts['icon_class'] ).'"></i>';
		}else if( strpos( $atts['icon_simple_line'], 'empty' ) === false ){
    		echo '<i aria-hidden="true" class="icon-'.esc_attr( $atts['icon_simple_line'] ).' element-icon '.esc_attr( $atts['icon_class'] ).'"></i>';
		}else if( strpos( $atts['icon_etline'], 'empty' ) === false ){
    		echo '<i aria-hidden="true" class="et-'.esc_attr( $atts['icon_etline'] ).' element-icon '.esc_attr( $atts['icon_class'] ).'"></i>';
		}
	}
		
	public static function display( $atts ){
		$extra_style ="";
		if(!empty($atts['bg_color'])){
			$bg_color = $atts['bg_color'];
			$extra_style = 'background-color:'.$bg_color.';';
		}
		
    
	?>	
		
		<div class="king-elements <?php echo esc_attr( $atts['class'] ); ?>" style="<?php echo esc_attr( $extra_style ); ?>"">
        	<?php
        	
        		self::icon( $atts );
        	
	        	if( !empty( $atts['title'] ) ){
	        		if( strpos( $atts['title'] , '<h' ) === false ){
	        			echo '<h4>'.esc_html($atts['title']).'</h4>';
	        		}else{
		        		print( $atts['title'] );
	        		}	
				}
				
				if( !empty( $atts['des'] ) ){
					if( strpos( $atts['des'] , '<' ) === false ){
	        			print( '<p>'.$atts['des'].'</p>' );
	        		}else{
		        		print( $atts['des'] );
	        		}
				}
				if( !empty( $atts['link'] ) ){
					echo '<a href="'.esc_url($atts['link']).'" class="'.esc_attr($atts['linkclass']).'"><i class="fa fa-caret-right"></i> '.__( 'Read More', 'aloom' ).'</a>';
				}
			?>		
        </div>
		
	<?php	
	}
	
	public static function sec2( $atts ){
		
		$image = $atts['image'];
		if((int)$image > 0 && ($image_url = wp_get_attachment_url( $image, 'thumbnail' )) !== false) {
	        
	    }else{
		    $image_url = THEME_URI.'/assets/images/default.png';
	    }
    
	?>	
		<div class="box">
			<img src="<?php echo esc_url( $image_url ); ?>" alt="">
			<h5>
				<?php 
					if( $atts['link'] != '' )echo '<a href="'.esc_url( $atts['link'] ).'">';
					echo esc_html($atts['title']);
					if( $atts['link'] != '' )echo '</a>'; 
				?>
			</h5>
			<p>
				<?php print( $atts['des'] ); ?>
			</p>
		</div>
		
	<?php	
	}	
		
	public static function flex_sliders( $content, $class ) {
	 
		$rgex = '\[(\[?)(vc_tab)(?![\w-])([^\]\/]*(?:\/(?!\])[^\]\/]*)*?)(?:(\/)\]|\](?:([^\[]*+(?:\[(?!\/\2\])[^\[]*+)*+)\[\/\2\])?)(\]?)';
		$content = preg_replace( '/'.$rgex.'/s', '<li>$5</li>', $content );
	?>
		<div class="slider <?php echo esc_attr($class); ?>">
			<div class="flexslider carousel">
				<ul class="slides">
					<?php echo do_shortcode( $content ); ?>
				</ul>
			</div>
		</div>
		
	<?php		
			
	}
	
	public static function ipad_sliders( $content, $class ) {
	 
		$rgex = '\[(\[?)(vc_tab)(?![\w-])([^\]\/]*(?:\/(?!\])[^\]\/]*)*?)(?:(\/)\]|\](?:([^\[]*+(?:\[(?!\/\2\])[^\[]*+)*+)\[\/\2\])?)(\]?)';
		$content = preg_replace( '/'.$rgex.'/s', '<div class="item">$5</div>', $content );
	?>
	 <div class="ms-phone-template">
		<div class="ms-phone-cont">
			<img src="<?php echo THEME_URI; ?>/assets/images/phone.png" class="ms-phone-bg" alt="" />
			<div class="owl-demo8 ms-phone-slider-cont">
				<div class="owl-carousel">
				    <?php echo do_shortcode( $content ); ?>
				</div>
			</div>
		</div>
	</div>
	<?php		
			
	}
		
	public static function owl_carousel( $content, $class ) {
	 
		$rgex = '\[(\[?)(vc_tab)(?![\w-])([^\]\/]*(?:\/(?!\])[^\]\/]*)*?)(?:(\/)\]|\](?:([^\[]*+(?:\[(?!\/\2\])[^\[]*+)*+)\[\/\2\])?)(\]?)';
		$content = preg_replace( '/'.$rgex.'/s', '<div class="item">$5</div>', $content );
		
		if(empty($class))$class = 'owl-demo';
		
		if( strpos( $class, 'owl-demo' ) === false ){
			$class .= ' owl-demo';
		}
		
	?>
		<div class="<?php echo esc_attr( $class ); ?>">
			<div class="owl-carousel">
		    	<?php echo do_shortcode( $content ); ?>
			</div>
		</div>
	<?php			
	}
			
	public static function icon_tabs( $content, $class ) {
	 
		$rgex = '\[(\[?)(vc_tab)(?![\w-])([^\]\/]*(?:\/(?!\])[^\]\/]*)*?)(?:(\/)\]|\](?:([^\[]*+(?:\[(?!\/\2\])[^\[]*+)*+)\[\/\2\])?)(\]?)';
		$navs = explode( '{-x-}', preg_replace( '/'.$rgex.'/s', '$3{-x-}', $content ) );
		$nav = '';
		foreach( $navs as $prx ){
			if( $prx == '' ){
				break;
			}
			preg_match_all('/(\w+)\s*=\s*"(.*?)"/', $prx, $matches);
			$atts = array( 'title' => '', 'icon' => 'leaf' );
			if( count( $matches[1] ) ){
				foreach( $matches[1] as $k => $v ){
					if( isset( $matches[2] ) ){
						if( isset( $matches[2][$k] ) ){
							$atts[ $v ] = $matches[2][$k];
						}
					}
				}
			}
			$nav .= '<div class="item"><i title="'.esc_attr($atts['title']).'" class="fa fa-'.esc_attr($atts['icon']).'"></i></div>';
		}
		$content = preg_replace( '/'.$rgex.'/s', '<div class="item">$5</div>', $content );
		
		if(empty($class))$class = '';
	?>
		<div id="sync4" class="owl-carousel <?php echo esc_attr( $class ); ?>">
		    <?php print( $nav ); ?>
		</div>
		<div class="clearfix margin_bottom5"></div>
		<div id="sync3" class="owl-carousel">
			<?php echo do_shortcode( $content ); ?>
		</div>
	<?php			
	}
	
	
}	