<?php

/*
*	Register extend component for Visual Composer
*	king-theme.com
*/


if (function_exists('vc_map')) {

	if(!function_exists('king_extend_visual_composer')){
		
		add_action( 'init', 'king_extend_visual_composer' );
		function king_extend_visual_composer(){
			
			global $vc_column_width_list, $king;
			$vc_is_wp_version_3_6_more = version_compare( preg_replace( '/^([\d\.]+)(\-.*$)/', '$1', get_bloginfo( 'version' ) ), '3.6' ) >= 0;
			 
			vc_map( array(
		    
		        "name" => __("Row", 'aloom'),
		        "base" => "vc_row",
		        "is_container" => true,
		        "icon" => "icon-wpb-row",
		        "show_settings_on_create" => true,
		        "category" => THEME_NAME.' Theme',
		        "description" => __('Place content elements inside the row', 'aloom'),
		        "params" => array(
		          array(
		            "type" => "textfield",
		            "heading" => __("ID Name for Navigation", 'aloom'),
		            "param_name" => "king_id",
		            "description" => __("If this row wraps the content of one of your sections, set an ID. You can then use it for navigation. Ex: work", 'aloom')
		          ),
		           array(
		            "type" => "attach_image",
		            "heading" => __("Background Image", 'aloom'),
		            "param_name" => "bg_image",
		            "description" => __("Select backgound color for the row.", 'aloom')
		          ),
		          array(
		            "type" => "dropdown",
		            "heading" => __('Background Repeat', 'aloom'),
		            "param_name" => "king_bg_repeat",
		            "value" => array(
		              __("Repeat-Y", 'aloom') => 'repeat-y',
		              __("Repeat", 'aloom') => 'repeat',
		              __('No Repeat', 'aloom') => 'no-repeat',
		              __('Repeat-X', 'aloom') => 'repeat-x'
		            )
		          ),
		          array(
		            "type" => "colorpicker",
		            "heading" => __('Background Color', 'aloom'),
		            "param_name" => "bg_color",
		            "description" => __("You can set a color over the background image. You can make it more or less opaque, by using the next setting. Default: white ", 'aloom')
		          ),
		          array(
		            "type" => "textfield",
		            "heading" => __('Background Color Opacity', 'aloom'),
		            "param_name" => "king_color_opacity",
		            "description" => __("Set an opacity value for the color(values between 0-100). 0 means no color while 100 means solid color. Default: 70 ", 'aloom')
		          ),
		          array(
		            "type" => "textfield",
		            "heading" => __("Padding Top", 'aloom'),
		            "param_name" => "king_padding_top",
		            "description" => __("Enter a value and it will be used for padding-top(px). As an alternative, use the 'Space' element.", 'aloom')
		          ),
		          array(
		            "type" => "textfield",
		            "heading" => __("Padding Bottom", 'aloom'),
		            "param_name" => "king_padding_bottom",
		            "description" => __("Enter a value and it will be used for padding-bottom(px). As an alternative, use the 'Space' element.", 'aloom')
		          ),
		          array(
		            "type" => "textfield",
		            "heading" => __("Container class name", 'aloom'),
		            "param_name" => "king_class_container",
		            "description" => __("Custom class name for container of this row", 'aloom')
		          ),		          
		          array(
		            "type" => "textfield",
		            "heading" => __("Section class name", 'aloom'),
		            "param_name" => "king_class",
		            "description" => __("Custom class for outermost wrapper.", 'aloom')
		          ),
		          array(
		            "type" => "dropdown",
		            "heading" => __('Type', 'aloom'),
		            "param_name" => "king_row_type",
		            "description" => __("Select template full-width if you want to background full of screen", 'aloom'),
		            "value" => array(
		              __("Content In Container", 'aloom') => 'container',
		              __("Fullwidth All", 'aloom')    => 'container_full',
		              __("Parallax", 'aloom')     => 'parallax'
		            )
		          ),
		        ),
		        "js_view" => 'VcRowView'
		      ) );
		      
		      
		      vc_map( array(
				'name' => __( 'Row', 'aloom' ), //Inner Row
				'base' => 'vc_row_inner',
				'content_element' => false,
				'is_container' => true,
				'icon' => 'icon-wpb-row',
				'weight' => 1000,
				'show_settings_on_create' => false,
				'description' => __( 'Place content elements inside the row', 'aloom' ),
				'params' => array(
					array(
						'type' => 'textfield',
						'heading' => __( 'Extra class name', 'aloom' ),
						'param_name' => 'king_class',
						'description' => __( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'aloom' )
					)
				),
				'js_view' => 'VcRowView'
			) );
		      
		      
		      vc_map( array(
				'name' => __( 'Column', 'aloom' ),
				'base' => 'vc_column',
				'is_container' => true,
				'content_element' => false,
				'params' => array(
					array(
						'type' => 'textfield',
						'heading' => __( 'Extra class name', 'aloom' ),
						'param_name' => 'el_class',
						'description' => __( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'aloom' )
					),					
					array(
						'type' => 'dropdown',
						'heading' => __( 'Animate Effect', 'aloom' ),
						'param_name' => 'el_animate',
						'value' => array(
							'---Select an animate---' => '',
							'Fade In' => 'animated eff-fadeIn',
							'From bottom up' => 'animated eff-fadeInUp',
							'From top down' => 'animated eff-fadeInDown',
							'From left' => 'animated eff-fadeInLeft',
							'From right' => 'animated eff-fadeInRight',
							'Zoom In' => 'animated eff-zoomIn',
							'Bounce In' => 'animated eff-bounceIn',
							'Bounce In Up' => 'animated eff-bounceInUp',
							'Bounce In Down' => 'animated eff-bounceInDown',
							'Bounce In Out' => 'animated eff-bounceInOut',
							'Flip In X' => 'animated eff-flipInX',
							'Flip In Y' => 'animated eff-flipInY',
						),
						'description' => __( 'Select animate effects to show this column when port-viewer scroll over', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Animate Delay', 'aloom' ),
						'param_name' => 'el_delay',
						'description' => __( 'Delay animate effect after number of mili seconds, e.g: 200 ', 'aloom' )
					),
					array(
						'type' => 'css_editor',
						'heading' => __( 'Css', 'aloom' ),
						'param_name' => 'css',
						'group' => __( 'Design options', 'aloom' )
					),
					array(
						'type' => 'dropdown',
						'heading' => __( 'Width', 'aloom' ),
						'param_name' => 'width',
						'value' => $vc_column_width_list,
						'group' => __( 'Width & Responsiveness', 'aloom' ),
						'description' => __( 'Select column width.', 'aloom' ),
						'std' => '1/1'
					),
					array(
						'type' => 'column_offset',
						'heading' => __( 'Responsiveness', 'aloom' ),
						'param_name' => 'offset',
						'group' => __( 'Width & Responsiveness', 'aloom' ),
						'description' => __( 'Adjust column for different screen sizes. Control width, offset and visibility settings.', 'aloom' )
					)
				),
				'js_view' => 'VcColumnView'
			) );
			
			
			vc_map( array(
				"name" => __( "Column", 'aloom' ),
				"base" => "vc_column_inner",
				"class" => "",
				"icon" => "",
				"wrapper_class" => "",
				"controls" => "full",
				"allowed_container_element" => false,
				"content_element" => false,
				"is_container" => true,
				"params" => array(
					array(
						"type" => "textfield",
						"heading" => __( "Extra class name", 'aloom' ),
						"param_name" => "el_class",
						"value" => "",
						"description" => __( "If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'aloom' )
					),
					array(
						'type' => 'dropdown',
						'heading' => __( 'Animate Effect', 'aloom' ),
						'param_name' => 'el_animate',
						'value' => array(
							'---Select an animate---' => '',
							'Fade In' => 'animated eff-fadeIn',
							'From bottom up' => 'animated eff-fadeInUp',
							'From top down' => 'animated eff-fadeInDown',
							'From left' => 'animated eff-fadeInLeft',
							'From right' => 'animated eff-fadeInRight',
							'Zoom In' => 'animated eff-zoomIn',
							'Bounce In' => 'animated eff-bounceIn',
							'Bounce In Up' => 'animated eff-bounceInUp',
							'Bounce In Down' => 'animated eff-bounceInDown',
							'Bounce In Out' => 'animated eff-bounceInOut',
							'Flip In X' => 'animated eff-flipInX',
							'Flip In Y' => 'animated eff-flipInY',
						),
						'description' => __( 'Select animate effects to show this column when port-viewer scroll over', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Animate Delay', 'aloom' ),
						'param_name' => 'el_delay',
						'description' => __( 'Delay animate effect after number of mili seconds, e.g: 200 ', 'aloom' )
					),
					array(
						"type" => "css_editor",
						"heading" => __( 'Css', 'aloom' ),
						"param_name" => "css",
						// "description" => __("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'aloom'),
						"group" => __( 'Design options', 'aloom' )
					),
					array(
						'type' => 'dropdown',
						'heading' => __( 'Width', 'aloom' ),
						'param_name' => 'width',
						'value' => $vc_column_width_list,
						'group' => __( 'Width & Responsiveness', 'aloom' ),
						'description' => __( 'Select column width.', 'aloom' ),
						'std' => '1/1'
					)
				),
				"js_view" => 'VcColumnView'
			) );
			
		    vc_map( array(
				'name' => __( 'X-Code Editor', 'aloom' ),
				'base' => 'vc_raw_html',
				'icon' => 'icon-wpb-raw-html',
				'category' => THEME_NAME.' Theme',
				'wrapper_class' => 'clearfix',
				'description' => __( 'Custom code php, html, javascript, css, shortcodes', 'aloom' ),
				'params' => array(
					array(
						'type' => 'textfield',
						'heading' => __( 'Title', 'aloom' ),
						'param_name' => 'title',
						'holder' => 'i',
						'description' => __( 'Label will display at VisualComposer admin', 'aloom' ),
						'admin_label' => true,
					),
					array(
						'type' => 'textarea_raw_html',
						'heading' => __( 'X-Code - PHP, HTML, Javascript, CSS, ShortCodes', 'aloom' ),
						'param_name' => 'content',
						'holder' => 'div',
						'value' => $king->ext['be']( '<p>I am X-Code Editor (king-theme.com)<br/>Click edit button to change this code</p>' ),
						'description' => __( 'Enter your HTML, PHP, JavaScript, Css, Shortcodes.', 'aloom' )
					),
				)
			));	
				      
		    vc_map( array(
				'name' => __( 'FAQs', 'aloom' ),
				'base' => 'faq',
				'icon' => 'fa fa-question-circle',
				'category' => THEME_NAME.' Theme',
				'wrapper_class' => 'clearfix',
				'description' => __( 'Output FAQs as accordion from faqs post type.', 'aloom' ),
				'params' => array(
					array(
						'type' => 'multiple',
						'heading' => __( 'Select Categories ( hold ctrl or shift to select multiple )', 'aloom' ),
						'param_name' => 'category',
						'values' => Su_Tools::get_terms( 'faq-category', 'slug' ),
						'admin_label' => true,
						'description' => __( 'Select category which you chosen for FAQs', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Amount', 'aloom' ),
						'param_name' => 'amount',
						'value' => 20,
						'admin_label' => true,
						'description' => __( 'Enter number of FAQs that you want to display. To edit FAQs, go to ', 'aloom' ).'/wp-admin/edit.php?post_type=faq'
					),
				)
			));
			
			
			/* Empty Space Element
			---------------------------------------------------------- */
			$mrt = array( '---Select Margin Top---' => '');
			$mrb = array( '---Select Margin Bottom---' => '');
			for( $i=1; $i <=15; $i++ ){
				$mrt[ $i.'0px'] =  $i.'0px';
				$mrb[ $i.'0px'] =  $i.'0px';
			}
			vc_map( array(
				'name' => __( 'Margin Spacing', 'aloom' ),
				'base' => 'margin',
				'icon' => 'fa fa-arrows-v',
				'show_settings_on_create' => true,
				'category' => THEME_NAME.' Theme',
				'description' => __( 'Blank spacing', 'aloom' ),
				'params' => array(
					array(
						'type' => 'dropdown',
						'heading' => __( 'Margin Top', 'aloom' ),
						'param_name' => 'margin_top',
						'admin_label' => true,
						'value' => $mrt
					),
					array(
						'type' => 'dropdown',
						'heading' => __( 'Margin Bottom', 'aloom' ),
						'param_name' => 'margin_bottom',
						'admin_label' => true,
						'value' => $mrb
					),
				),
			) );
				      										      
		    vc_map( array(
				'name' => __( 'King Loop', 'aloom' ),
				'base' => 'king_loop',
				'icon' => 'fa fa-star-o',
				'category' => THEME_NAME.' Theme',
				'wrapper_class' => 'clearfix',
				'description' => __( 'Output list of item template', 'aloom' ),
				'params' => array(
					array(
						'type' => 'taxonomy',
						'heading' => __( 'Categories', 'aloom' ),
						'param_name' => 'category',
						'values' => '',
						'admin_label' => true,
						'description' => __( 'Select Post type & categories  (Hold ctrl or command to select multiple)', 'aloom' )
					),
					array(
						'type' => 'radio',
						'heading' => __( 'How showing', 'aloom' ),
						'param_name' => 'showing',
						'value' => array(
							'Normal as Grids &nbsp; &nbsp; ' => 'grid',
							'Showing As Sliders' => 'slider',
						),
						'description' => ''
					),
					array(
						'type' => 'textarea_raw_html',
						'heading' => __( 'Item Format', 'aloom' ),
						'param_name' => 'format',
						'description' => __( 'Available params: {title}, {position}, {img}, {des}, {link}, {social}, {date}, {category}, {author}, {comment}, {price}, {per}, {submit-link}, {submit-text}, {des-li}, {des-br}, {day}, {month}', 'aloom' ),
						'value' => ''
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Number of items', 'aloom' ),
						'param_name' => 'items',
						'value' => 20,
						'admin_label' => true,
						'description' => __( 'Enter number of people to show', 'aloom' )
					),
					array(
						'type' => 'dropdown',
						'heading' => __( 'Number per row', 'aloom' ),
						'param_name' => 'per_row',
						'value' => array(
							'Four' => 4,
							'One' => 1,
							'Two' => 2,
							'Three' => 3,
							'Five' => 5,
						),
						'admin_label' => true,
						'description' => 'Number people display on 1 row'
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Class of Wrapper', 'aloom' ),
						'param_name' => 'class',
						'value' => '',
						'description' => __( 'Custom class name for wrapper', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Class of Odd Columns', 'aloom' ),
						'param_name' => 'odd_class',
						'value' => '',
						'description' => __( 'Custom class name for odd columns', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Class of Even Columns', 'aloom' ),
						'param_name' => 'even_class',
						'value' => '',
						'description' => __( 'Custom class name for even columns', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Image Size ( width x height )', 'aloom' ),
						'param_name' => 'img_size',
						'value' => '245x245',
						'description' => __( 'Set thumbnail size e.g: 245x245', 'aloom' )
					),	
					array(
						'type' => 'dropdown',
						'heading' => __( 'Hightlight Column', 'aloom' ),
						'param_name' => 'highlight',
						'value' => array(
							'Three' => 3,
							'None' => 0,
							'One' => 1,
							'Two' => 2,
							'Four' => 4,
							'Five' => 5,
						),
						'description' => 'Select column to set highlight (using for pricing table)'
					),				
					array(
						'type' => 'textfield',
						'heading' => __( 'Words Limit', 'aloom' ),
						'param_name' => 'words',
						'value' => 20,
						'description' => __( 'Limit words you want show as short description', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Offset', 'aloom' ),
						'param_name' => 'offset',
						'value' => 0,
						'description' => __( 'Set offset to start select sql from', 'aloom' )
					),
					array(
						'type' => 'dropdown',
						'heading' => __( 'Order By', 'aloom' ),
						'param_name' => 'order',
						'value' => array(
							'Descending' => 'DESC',
							'Ascending' => 'ASC',
							'Random' => 'rand',
							
						),
						'description' => ' &nbsp; '
					)
				)
			));
			
						
			 vc_map( array(
				'name' => __( 'Our Team', 'aloom' ),
				'base' => 'team',
				'icon' => 'fa fa-group',
				'category' => THEME_NAME.' Theme',
				'wrapper_class' => 'clearfix',
				'description' => __( 'Output our team template', 'aloom' ),
				'params' => array(
					array(
						'type' => 'multiple',
						'heading' => __( 'Select Category ( hold ctrl or shift to select multiple )', 'aloom' ),
						'param_name' => 'category',
						'values' => Su_Tools::get_terms( 'our-team-category', 'slug' ),
						'height' => '150px',
						'description' => __( 'Select category to display team', 'aloom' )
					),	
					array(
						'type' => 'select',
						'heading' => __( 'Select Template', 'aloom' ),
						'param_name' => 'template',
						'admin_label' => true,
						'values' => Su_Tools::get_templates( 'team' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Amount', 'aloom' ),
						'param_name' => 'items',
						'value' => 20,
						'description' => __( 'Enter number of people to show', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Words Limit', 'aloom' ),
						'param_name' => 'words',
						'value' => 20,
						'description' => __( 'Limit words you want show as short description', 'aloom' )
					),
					array(
						'type' => 'dropdown',
						'heading' => __( 'Order By', 'aloom' ),
						'param_name' => 'order',
						'value' => array(
							'Descending' => 'desc',
							'Ascending' => 'asc',
							'Random' => 'rand',
						),
						'description' => ' &nbsp; '
					)
				)
			));
			
			vc_map( array(
				'name' => __( 'Our Work (Portfolio)', 'aloom' ),
				'base' => 'work',
				'icon' => 'fa fa-send-o',
				'category' => THEME_NAME.' Theme',
				'wrapper_class' => 'clearfix',
				'description' => __( 'Our work for portfolio template.', 'aloom' ),
				'params' => array(
					array(
						'type' => 'multiple',
						'heading' => __( 'Select Categories ( hold ctrl or shift to select multiple )', 'aloom' ),
						'param_name' => 'tax_term',
						'values' => Su_Tools::get_terms( 'our-works-category', 'slug' ),
						'height' => '120px',
						'admin_label' => true,
						'description' => __( 'Select category which you chosen for Team items', 'aloom' )
					),					
					array(
						'type' => 'select',
						'heading' => __( 'Select Template', 'aloom' ),
						'param_name' => 'template',
						'admin_label' => true,
						'values' => Su_Tools::get_templates( 'work' )
					),
					array(
						'type' => 'dropdown',
						'heading' => __( 'Show Filter', 'aloom' ),
						'param_name' => 'filter',
						'value' => array(
							'No'	=> 'No',
							'Yes'	=> 'Yes',
						),
					),
					array(
						'type' => 'dropdown',
						'heading' => __( 'Item Margin', 'aloom' ),
						'param_name' => 'margin',
						'value' => array(
							'Yes'	=> 'Yes',
							'No'	=> 'No',
						),
					),
					array(
						'type' => 'select',
						'heading' => __( 'Items on Row', 'aloom' ),
						'param_name' => 'column',
						'values' => array(
							'2' => 'two',
							'3' => 'three',
							'4' => 'four',
							//'5' => 'five',
						),
						'description' => __( 'Choose number of items display on a row', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Items Limit', 'aloom' ),
						'param_name' => 'items',
						'value' => get_option( 'posts_per_page' ),
						'description' => __( 'Specify number of team that you want to show. Enter -1 to get all team', 'aloom' )
					),
					array(
						'type' => 'select',
						'heading' => __( 'Order By', 'aloom' ),
						'param_name' => 'order',
						'values' => array(
								'desc' => __( 'Descending', 'aloom' ),
								'asc' => __( 'Ascending', 'aloom' ),
								'rand' => __( 'Random', 'aloom' ),
						),
						'description' => ' &nbsp; '
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Class Css', 'aloom' ),
						'param_name' => 'class',
						'value' => '',
					),
				)
			));
			
			vc_map( array(
				'name' => __( 'Testimonials', 'aloom' ),
				'base' => 'testimonials',
				'icon' => 'fa fa-group',
				'category' => THEME_NAME.' Theme',
				'wrapper_class' => 'clearfix',
				'description' => __( 'Out testimonians post type.', 'aloom' ),
				'params' => array(
					array(
						'type' => 'multiple',
						'heading' => __( 'Select Categories ( hold ctrl or shift to select multiple )', 'aloom' ),
						'param_name' => 'category',
						'values' => Su_Tools::get_terms( 'testimonials-category', 'slug' ),
						'height' => '120px',
						'admin_label' => true,
						'description' => __( 'Select category which you chosen for Team items', 'aloom' )
					),	
					array(
						'type' => 'select',
						'heading' => __( 'Select Template', 'aloom' ),
						'param_name' => 'template',
						'admin_label' => true,
						'values' => Su_Tools::get_templates( 'testimonial' )
					),	
					array(
						'type' => 'textfield',
						'heading' => __( 'Items Limit', 'aloom' ),
						'param_name' => 'items',
						'value' => get_option( 'posts_per_page' ),
						'description' => __( 'Specify number of team that you want to show. Enter -1 to get all', 'aloom' )
					),						
					array(
						'type' => 'textfield',
						'heading' => __( 'Limit Words', 'aloom' ),
						'param_name' => 'words',
						'value' => 20,
						'description' => __( 'Limit words you want show as short description', 'aloom' )
					),
					array(
						'type' => 'select',
						'heading' => __( 'Order By', 'aloom' ),
						'param_name' => 'order',
						'values' => array(
								'desc' => __( 'Descending', 'aloom' ),
								'asc' => __( 'Ascending', 'aloom' ),
								'rand' => __( 'Random', 'aloom' ),
						),
						'description' => ' &nbsp; '
					)
				)
			));
						
			vc_map( array(
			
				'name' => __( 'Pie Chart', 'aloom' ),
				'base' => 'piechart',
				'icon' => 'fa fa-pie-chart',
				'category' => THEME_NAME.' Theme',
				'wrapper_class' => 'clearfix',
				'description' => __( 'Out testimonians post type.', 'aloom' ),
				'params' => array(

					array(
						'type' => 'select',
						'param_name' => 'size',
						'values' => array(
							'1' => '1',
							'2' => '2',
							'3' => '3',
							'4' => '4',
							'5' => '5',
							'6' => '6',
							'7' => '7',
							'8' => '8',
						),
						'value' => 7,
						'heading' => __( 'Size', 'aloom' ),
						'description' => __( 'Size of chart', 'aloom' )
					),
					
					array(
						'type' => 'select',
						'param_name' => 'style',
						'values' => array(
							'piechart1' => 'Pie Chart 1',
							'piechart2' => 'Pie Chart 2 (auto width by size)',
							'piechart3' => 'Pie Chart 3 (white color)'
						),
						'value' => 7,
						'heading' => __( 'Size', 'aloom' ),
						'description' => __( 'Size of chart', 'aloom' )
					),
					array(
						'param_name' => 'percent',
						'type' 	=> 'textfield',
						'value' => 75,
						'admin_label' => true,
						'heading' => __( 'Percent', 'aloom' ),
						'description' => __( 'Percent value of chart', 'aloom' )
					),
					array(
			            "type" => "colorpicker",
			            "heading" => __('Color', 'aloom'),
			            "param_name" => "color",
			            "description" => __("Color of chart", 'aloom')
			        ),
					array(
						'param_name' => 'text',
						'type' 	=> 'textfield',
						'heading' => __( 'Text', 'aloom' ),
						'description' => __( 'The text bellow chart', 'aloom' ),
						'admin_label' => true,
					),
					array(
						'param_name' => 'class',
						'type' 	=> 'textfield',
						'heading' => __( 'Class', 'aloom' ),
						'description' => __( 'Extra CSS class', 'aloom' )
					)
					
				)
			));

			vc_map( array(
			
				'name' => __( 'Pricing Table', 'aloom' ),
				'base' => 'pricing',
				'icon' => 'fa fa-table',
				'category' => THEME_NAME.' Theme',
				'wrapper_class' => 'clearfix',
				'description' => __( 'Display Pricing Plan Table', 'aloom' ),
				'params' => array(
					array(
						'type' => 'select',
						'heading' => __( 'Select Categories ( hold ctrl or shift to select multiple )', 'aloom' ),
						'param_name' => 'category',
						'values' => Su_Tools::get_terms( 'pricing-tables-category', 'slug', null, '---Select Category---' ),
						'admin_label' => true,
						'description' => __( 'Select category which you chosen for Pricing Table', 'aloom' )
					),
					array(
						'type' => 'select',
						'param_name' => 'amount',
						'values' => array(
								'1' => '1',
								'2' => '2',
								'3' => '3',
								'4' => '4',
						),
						'value' => 4,
						'heading' => __( 'Amount', 'aloom' ),
						'description' => __( 'Number of columns', 'aloom' )
					),	
					array(
						'type' => 'select',
						'param_name' => 'active',
						'values' => array(
								'1' => '1',
								'2' => '2',
								'3' => '3',
								'4' => '4',
						),
						'value' => 3,
						'heading' => __( 'Active Column', 'aloom' ),
						'description' => __( 'Select column to highlight', 'aloom' )
					),
					array(
						'type' => 'select',
						'heading' => __( 'Select Template', 'aloom' ),
						'param_name' => 'template',
						'admin_label' => true,
						'values' => Su_Tools::get_templates( 'pricing' )
					),
					array(
						'param_name' => 'icon',
						'type' 	=> 'icon',
						'heading' => __( 'Icon', 'aloom' ),
						'description' => __( 'the icon display on per row', 'aloom' )
					),
					array(
						'param_name' => 'currency',
						'type' 	=> 'textfield',
						'heading' => __( 'Currency', 'aloom' ),
						'description' => __( 'The currency icon displayed next to the price', 'aloom' )
					),
					array(
						'param_name' => 'class',
						'type' 	=> 'textfield',
						'heading' => __( 'Class', 'aloom' ),
						'description' => __( 'Extra CSS class', 'aloom' )
					)
					
				)
			));

			vc_map( array(
			
				'name' => __( 'Progress Bars', 'aloom' ),
				'base' => 'progress',
				'icon' => 'fa fa-line-chart',
				'category' => THEME_NAME.' Theme',
				'wrapper_class' => 'clearfix',
				'description' => __( 'Display Progress Bars', 'aloom' ),
				'params' => array(

					array(
						'type' => 'select',
						'param_name' => 'style',
						'values' => array(
								'1' => '1',
								'2' => '2',
								'3' => '3',
								'4' => '4',
						),
						'heading' => __( 'Style', 'aloom' ),
						'description' => __( 'Style of progress bar', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'param_name' => 'percent',
						'value' => 75,
						'admin_label' => true,
						'heading' => __( 'Percent', 'aloom' ),
						'description' => __( 'Percent value of progress bar', 'aloom' )
					),
					array(
						'type' => 'colorpicker',
						'param_name' => 'color',
						'value' => '#333333',
						'heading' => __( 'Color', 'aloom' ),
						'description' => __( 'Color of progress bar', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'param_name' => 'text',
						'admin_label' => true,
						'heading' => __( 'Text', 'aloom' ),
						'description' => __( 'The text bellow chart', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'param_name' => 'class',
						'heading' => __( 'Class', 'aloom' ),
						'description' => __( 'Extra CSS class', 'aloom' )
					)
					
				)
			));
			
			vc_map( array(
			
				'name' => __( 'Divider', 'aloom' ),
				'base' => 'divider',
				'icon' => 'icon-wpb-ui-separator',
				'category' => THEME_NAME.' Theme',
				'wrapper_class' => 'clearfix',
				'description' => __( 'List of horizontal divider line', 'aloom' ),
				'params' => array(

					array(
						'type' => 'select',
						'param_name' => 'style',
						'values' => array(
								'1' => 'Style 1',
								'2' => 'Style 2',
								'3' => 'Style 3',
								'4' => 'Style 4',
								'5' => 'Style 5',
								'6' => 'Style 6',
								'7' => 'Style 7',
								'8' => 'Style 8',
								'9' => 'Style 9',
								'10' => 'Style 10',
								'11' => 'Style 11',
								'12' => 'Style 12',
								'13' => 'Style 13',
								' ' => 'Divider Line',
						),
						'admin_label' => true,
						'heading' => __( 'Style', 'aloom' ),
						'description' => __( 'Style of divider', 'aloom' )
					),
					array(
						'type' => 'icon',
						'param_name' => 'icon',
						'heading' => __( 'Icon', 'aloom' ),
						'description' => __( 'Select icon on divider', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'param_name' => 'class',
						'heading' => __( 'Class', 'aloom' ),
						'description' => __( 'Extra CSS class', 'aloom' )
					)
					
				)
			));
					
			vc_map( array(
			
				'name' => __( 'Title Styles', 'aloom' ),
				'base' => 'titles',
				'category' => THEME_NAME.' Theme',
				'wrapper_class' => 'clearfix',
				'icon' => 'fa fa-university',
				'description' => __( 'List of Title Styles', 'aloom' ),
				'params' => array(

					array(
						'type' => 'select',
						'param_name' => 'type',
						'values' => array(
								'h1' => 'H1',
								'h2' => 'H2',
								'h3' => 'H3',
								'h4' => 'H4',
								'h5' => 'H5',
								'h6' => 'H6',
						),
						'admin_label' => true,
						'heading' => __( 'Head Tag', 'aloom' ),
						'description' => __( 'Select Header Tag', 'aloom' )
					),
					array(
						'type' => 'textarea_raw_html',
						'param_name' => 'text',
						'heading' => __( 'Title Text', 'aloom' ),
						'holder' => 'div',
						'value' => ''
					),
					array(
						'type' => 'select',
						'param_name' => 'effect',
						'values' => array(
							'' => '--Select Effect--', 
							' animated eff-fadeIn delay-200ms' =>'Fade In',
							' animated eff-fadeInUp delay-200ms' =>'From bottom up',
							' animated eff-fadeInUp delay-300ms' =>'From bottom up 300ms',
							' animated eff-fadeInDown delay-200ms' =>'From top down',
							' animated eff-fadeInLeft delay-200ms' =>'From left',
							' animated eff-fadeInRight delay-200ms' =>'From right',
							' animated eff-zoomIn delay-200ms' =>'Zoom In',
							' animated eff-bounceIn delay-200ms' =>'Bounce In',
							' animated eff-bounceInUp delay-200ms' =>'Bounce In Up',
							' animated eff-bounceInDown delay-200ms' =>'Bounce In Down',
							' animated eff-bounceInOut delay-200ms' =>'Bounce In Out',
							' animated eff-flipInX delay-200ms' =>'Flip In X',
							' animated eff-flipInY delay-200ms' =>'Flip In Y',
						),
						'heading' => __( 'Effect', 'aloom' ),
						'description' => __( 'The effect showing when scroll over', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'param_name' => 'class',
						'heading' => __( 'Class', 'aloom' ),
						'description' => __( 'CSS class', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'param_name' => 'wrpclass',
						'heading' => __( 'Wrapper Class', 'aloom' ),
						'description' => __( 'Extra CSS class of wrapper', 'aloom' )
					)
					
				)
			));
			
			vc_map( array(
			
				'name' => __( 'Flip Clients', 'aloom' ),
				'base' => 'flip_clients',
				'icon' => 'fa fa-apple',
				'category' => THEME_NAME.' Theme',
				'wrapper_class' => 'clearfix',
				'description' => __( 'Display clients with flip styles', 'aloom' ),
				'params' => array(

					array(
						'type' => 'attach_image',
						'param_name' => 'img',
						'heading' => __( 'Logo Image', 'aloom' ),
						'description' => __( 'Upload the client\'s logo', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'param_name' => 'title',
						'heading' => __( 'Title', 'aloom' ),
						'admin_label' => true,
						'description' => __( 'The name of client', 'aloom' )
					),						
					array(
						'type' => 'textfield',
						'param_name' => 'link',
						'heading' => __( 'Link', 'aloom' ),
						'description' => __( 'Link to client website', 'aloom' )
					),					
					array(
						'type' => 'textfield',
						'param_name' => 'des',
						'heading' => 'Description',
						'description' => __( 'Short Descript will show when hover', 'aloom' ),
						'admin_label' => true,
					),
					array(
						'type' => 'textfield',
						'param_name' => 'class',
						'heading' => __( 'Class', 'aloom' ),
						'description' => __( 'Extra CSS class', 'aloom' )
					)
					
				)
			));
			
			vc_map( array(
			
				'name' => __( 'Lastest Products', 'aloom' ),
				'base' => 'lastest_products',
				'icon' => 'fa fa-shopping-cart',
				'category' => THEME_NAME.' Theme',
				'wrapper_class' => 'clearfix',
				'description' => __( 'Display lastest products from woocommerce plugin', 'aloom' ),
				'params' => array(

					array(
						'type' => 'textfield',
						'param_name' => 'items',
						'heading' => __( 'Number Items', 'aloom' ),
						'admin_label' => true,
						'description' => __( 'Number items you want to display (Max 8 items)', 'aloom' )
					),
					array(
						'type' => 'textarea_raw_html',
						'param_name' => 'des',
						'heading' => __( 'Description text', 'aloom' ),
						'holder' => 'div',
						'value' => ''
					),
					
				)
			));
			vc_map( array(
				'name' => __( 'Posts - '.THEME_NAME, 'aloom' ),
				'base' => 'posts',
				'icon' => 'fa fa-th-list',
				'category' => THEME_NAME.' Theme',
				'wrapper_class' => 'clearfix',
				'description' => __( 'List posts by other layouts of theme', 'aloom' ),
				'params' => array(
					array(
						'type' => 'multiple',
						'heading' => __( 'Select Category ( hold ctrl or shift to select multiple )', 'aloom' ),
						'param_name' => 'category',
						'values' => Su_Tools::get_terms( 'category', 'slug' ),
						'height' => '150px',
						'description' => __( 'Select category to display Posts', 'aloom' )
					),	
					array(
						'type' => 'select',
						'heading' => __( 'Select Template', 'aloom' ),
						'param_name' => 'template',
						'admin_label' => true,
						'values' => Su_Tools::get_templates( 'post' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Amount', 'aloom' ),
						'param_name' => 'items',
						'value' => 20,
						'description' => __( 'Enter number of people to show', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Words Limit', 'aloom' ),
						'param_name' => 'words',
						'value' => 20,
						'description' => __( 'Limit words you want show as short description', 'aloom' )
					),
					array(
						'type' => 'dropdown',
						'heading' => __( 'Order By', 'aloom' ),
						'param_name' => 'order',
						'value' => array(
							'Descending' => 'desc',
							'Ascending' => 'asc'
						),
						'description' => ' &nbsp; '
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Class Css', 'aloom' ),
						'param_name' => 'class'
					),
				)
			));
			
			vc_map( array(
				'name' => __( 'Accordion', 'aloom' ),
				'base' => 'vc_accordion',
				'show_settings_on_create' => false,
				'is_container' => true,
				'icon' => 'icon-wpb-ui-accordion',
				'category' => THEME_NAME.' Theme',
				'description' => __( 'Collapsible content panels', 'aloom' ),
				'params' => array(
					array(
						'type' => 'textfield',
						'heading' => __( 'Widget title', 'aloom' ),
						'param_name' => 'title',
						'description' => __( 'Enter text which will be used as widget title. Leave blank if no title is needed.', 'aloom' )
					),
					array(
						'type' => 'select',
						'heading' => __( 'Style', 'aloom' ),
						'param_name' => 'style',
						'values' => array(
							'1' => '1',
							'2' => '2',
							'3' => '3',
							'2 white' => 'white color',
						),
						'description' => __( 'Select style of accordion.', 'aloom' )
					),
					array(
						'type' => 'select',
						'heading' => __( 'Icon', 'aloom' ),
						'param_name' => 'icon',
						'values' => array(
							'icon-plus' => 'Icon Plus',
							'icon-plus-circle' => 'Plus Circle',
							'icon-plus-square-1' => 'Plus Square 1',
							'icon-plus-square-2' => 'Plus Square 2',
							'icon-arrow' => 'Icon Arrow',
							'icon-arrow2' => 'Icon Arrow2',
							'icon-arrow-circle-1' => 'Arrow Circle 1',
							'icon-arrow-circle-2' => 'Arrow Circle 2',
							'icon-chevron' => 'Icon Chevron',
							'icon-chevron-circle' => 'Icon Chevron Circle',
							'icon-caret' => 'Icon Caret',
							'icon-caret-square' => 'Icon Caret Square',
							'icon-folder-1' => 'Icon Folder 1',
							'icon-folder-2' => 'Icon Folder 2',
						),
						'description' => __( 'Select icon display on each spoiler', 'aloom' )
					),	
					array(
						'type' => 'textfield',
						'heading' => __( 'Active section', 'aloom' ),
						'param_name' => 'active_tab',
						'description' => __( 'Enter section number to be active on load or enter false to collapse all sections.', 'aloom' )
					),
					array(
						'type' => 'checkbox',
						'heading' => __( 'Allow collapsible all', 'aloom' ),
						'param_name' => 'collapsible',
						'description' => __( 'Select checkbox to allow all sections to be collapsible.', 'aloom' ),
						'value' => array( __( 'Allow', 'aloom' ) => 'yes' )
					),
					array(
						'type' => 'checkbox',
						'heading' => __( 'Disable keyboard interactions', 'aloom' ),
						'param_name' => 'disable_keyboard',
						'description' => __( 'Disables keyboard arrows interactions LEFT/UP/RIGHT/DOWN/SPACES keys.', 'aloom' ),
						'value' => array( __( 'Disable', 'aloom' ) => 'yes' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Extra class name', 'aloom' ),
						'param_name' => 'el_class',
						'description' => __( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'aloom' )
					)
				),
				'custom_markup' => '
					<div class="wpb_accordion_holder wpb_holder clearfix vc_container_for_children">
					%content%
					</div>
					<div class="tab_controls">
					    <a class="add_tab" title="' . __( 'Add section', 'aloom' ) . '"><span class="vc_icon"></span> <span class="tab-label">' . __( 'Add section', 'aloom' ) . '</span></a>
					</div>
				',
					'default_content' => '
				    [vc_accordion_tab title="' . __( 'Section 1', 'aloom' ) . '"][/vc_accordion_tab]
				    [vc_accordion_tab title="' . __( 'Section 2', 'aloom' ) . '"][/vc_accordion_tab]
				',
				'js_view' => 'VcAccordionView'
			));

			
			$tab_id_1 = 'def' . time() . '-1-' . rand( 0, 100 );
			$tab_id_2 = 'def' . time() . '-2-' . rand( 0, 100 );
			vc_map( array(
				"name" => __( 'Tabs - Sliders', 'aloom' ),
				'base' => 'vc_tabs',
				'show_settings_on_create' => false,
				'is_container' => true,
				'icon' => 'icon-wpb-ui-tab-content',
				'category' => THEME_NAME.' Theme',
				'description' => __( 'Custom Tabs, Sliders', 'aloom' ),
				'params' => array(
					array(
						'type' => 'select',
						'heading' => __( 'Display as', 'aloom' ),
						'values' => array(
							'tabs' => 'Display as Tabs',
							'vertical' => 'Vertical Style',
							'icon-tabs' => 'Display as Icon Tabs Slider',
							'ipad-sliders' => 'Display as iPad Sliders',
							'sliders' => 'Display as Flex Sliders',
							'owl' => 'Display as Owl Carousel'
						),
						'admin_label' => true,
						'param_name' => 'type',
						'description' => __( 'You can choose to display as tabs or sliders', 'aloom' )
					),					
					array(
						'type' => 'dropdown',
						'heading' => __( 'Auto rotate tabs', 'aloom' ),
						'param_name' => 'interval',
						'value' => array( __( 'Disable', 'aloom' ) => 0, 3, 5, 10, 15 ),
						'std' => 0,
						'description' => __( 'Auto rotate tabs each X seconds.', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Extra class name', 'aloom' ),
						'param_name' => 'el_class',
						'description' => __( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'aloom' )
					)
				),
				'custom_markup' => '
			<div class="wpb_tabs_holder wpb_holder vc_container_for_children">
			<ul class="tabs_controls">
			</ul>
			%content%
			</div>'
			, 
			'default_content' => '
			[vc_tab title="' . __( 'Tab 1', 'aloom' ) . '" tab_id="' . $tab_id_1 . '"][/vc_tab]
			[vc_tab title="' . __( 'Tab 2', 'aloom' ) . '" tab_id="' . $tab_id_2 . '"][/vc_tab]
			',
				'js_view' => $vc_is_wp_version_3_6_more ? 'VcTabsView' : 'VcTabsView35'
			) );


			vc_map( array(
				'name' => __( 'Tab', 'aloom' ),
				'base' => 'vc_tab',
				'allowed_container_element' => 'vc_row',
				'is_container' => true,
				'content_element' => false,
				'params' => array(
					array(
						'type' => 'textfield',
						'heading' => __( 'Title', 'aloom' ),
						'param_name' => 'title',
						'description' => __( 'Tab title.', 'aloom' )
					),
					array(
						'type' => 'icon',
						'param_name' => 'icon',
						'heading' => __( 'Awesome Icon ', 'aloom' ),
						'description' => __( 'Select Icon for service box', 'aloom' ),
						'admin_label' => true,
					),
					array(
						'type' => 'icon-simple',
						'param_name' => 'icon_simple_line',
						'heading' => __( 'Simple-line Icon ', 'aloom' ),
						'description' => __( 'Select Icon for service box', 'aloom' ),
						'admin_label' => true,
					),
					array(
						'type' => 'icon-etline',
						'param_name' => 'icon_etline',
						'heading' => __( 'Etline Icon ', 'aloom' ),
						'description' => __( 'Select Icon for service box', 'aloom' ),
						'admin_label' => true,
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Extra Class', 'aloom' ),
						'param_name' => 'el_class',
					),
					array(
						'type' => 'tab_id',
						'heading' => __( 'Tab ID', 'aloom' ),
						'param_name' => "tab_id"
					)
				),
				'js_view' => $vc_is_wp_version_3_6_more ? 'VcTabView' : 'VcTabView35'
			) );

			vc_map( array(
				'name' => __( 'Video Background', 'aloom' ),
				'base' => 'videobg',
				
				'allowed_container_element' => 'vc_row',
				'content_element' => true,
				'is_container' => true,
				'show_settings_on_create' => false,
				
				'icon' => 'fa fa-file-video-o',
				'category' => THEME_NAME.' Theme',
				
				'description' => __( 'Background video for sections', 'aloom' ),
				'params' => array(
					array(
						'type' => 'textfield',
						'heading' => __( 'Background Video ID', 'aloom' ),
						'param_name' => 'id',
						'admin_label' => true,
						'description' => __( 'Imput video id from you, E.g: cUhPA5qIxDQ', 'aloom' )
					),					
					array(
						'type' => 'select',
						'heading' => __( 'Sound', 'aloom' ),
						'param_name' => 'sound',
						'values' => array(
							'no' => 'No, Thanks!',
							'yes' => 'Yes, Please!',
						),
						'admin_label' => true,
						'description' => __( 'Play sound or mute mode when video playing', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'admin_label' => true,
						'heading' => __( 'Height', 'aloom' ),
						'param_name' => "height",
						'description' => __( 'Height of area video. E.g: 500', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Extra class name', 'aloom' ),
						'param_name' => 'class',
						'description' => __( 'Use this field to add a class name and then refer to it in your css file.', 'aloom' )
					)
				),
				'js_view' => 'VcColumnView'
				
			) );

			vc_map( array(
			
				'name' => THEME_NAME.' Elements',
				'base' => 'elements',
				'icon' => 'fa fa-graduation-cap',
				'category' => THEME_NAME.' Theme',
				'description' => __( 'All elements use in theme', 'aloom' ),
				'params' => array(

					array(
						'type' => 'attach_image',
						'param_name' => 'image',
						'heading' => __( 'Image ', 'aloom' ),
						'description' => __( 'Select image for service box', 'aloom' ),
						'admin_label' => true,
					),
					array(
						'type' => 'icon',
						'param_name' => 'icon_awesome',
						'heading' => __( 'Awesome Icon ', 'aloom' ),
						'description' => __( 'Select Icon for service box', 'aloom' ),
						'admin_label' => true,
					),					
					array(
						'type' => 'icon-simple',
						'param_name' => 'icon_simple_line',
						'heading' => __( 'Simple-line Icon ', 'aloom' ),
						'description' => __( 'Select Icon for service box', 'aloom' ),
						'admin_label' => true,
					),
					array(
						'type' => 'icon-etline',
						'param_name' => 'icon_etline',
						'heading' => __( 'Etline Icon ', 'aloom' ),
						'description' => __( 'Select Icon for service box', 'aloom' ),
						'admin_label' => true,
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Icon Class name', 'aloom' ),
						'param_name' => "icon_class"
					),
					array(
						'type' => 'colorpicker',
						'heading' => __('Background Color', 'aloom'),
						'param_name' => 'bg_color',
						'description' => __('You can set a color over the box. Default: none ', 'aloom')
					),
					array(
						'type' => 'textarea_raw_html',
						'heading' => __( 'Short Description', 'aloom' ),
						'param_name' => 'des',
						'value' => ''
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'External link', 'aloom' ),
						'param_name' => 'link',
						'description' => __( 'External link read more', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'External link class name', 'aloom' ),
						'param_name' => 'linkclass'
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Extra class name', 'aloom' ),
						'param_name' => 'class',
						'description' => __( 'Use this field to add a class name and then refer to it in your css file.', 'aloom' )
					)
				)
			) );
						
						
						
			/* Owl Image Carousel
			---------------------------------------------------------- */
						
			$target_arr = array(
				__( 'Same window', 'aloom' ) => '_self',
				__( 'New window', 'aloom' ) => '_blank'
			);
			vc_map( array(
				'name' => __( 'Carousel Photos', 'aloom' ),
				'base' => 'king_carousel',
				'icon' => 'icon-wpb-images-carousel',
				'category' => THEME_NAME.' Theme',
				'description' => __( 'Animated carousel with images', 'aloom' ),
				'params' => array(
					array(
						'type' => 'attach_images',
						'heading' => __( 'Images', 'aloom' ),
						'param_name' => 'images',
						'value' => '',
						'description' => __( 'Select images from media library.', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Carousel size', 'aloom' ),
						'param_name' => 'img_size',
						'value' => 'thumbnail',
						'description' => __( 'Enter image size. Example: thumbnail, medium, large, full or other sizes defined by current theme. Alternatively enter image size in pixels: 200x100 (Width x Height). Leave empty to use "thumbnail" size. If used slides per view, this will be used to define carousel wrapper size.', 'aloom' )
					),
					array(
						'type' => 'dropdown',
						'heading' => __( 'On click action', 'aloom' ),
						'param_name' => 'onclick',
						'value' => array(
							__( 'Open prettyPhoto', 'aloom' ) => 'link_image',
							__( 'None', 'aloom' ) => 'link_no',
							__( 'Open custom links', 'aloom' ) => 'custom_link'
						),
						'description' => __( 'Select action for click event.', 'aloom' )
					),
					array(
						'type' => 'exploded_textarea',
						'heading' => __( 'Custom links', 'aloom' ),
						'param_name' => 'custom_links',
						'description' => __( 'Enter links for each slide (Note: divide links with linebreaks (Enter)).', 'aloom' ),
						'dependency' => array(
							'element' => 'onclick',
							'value' => array( 'custom_link' )
						)
					),
					array(
						'type' => 'dropdown',
						'heading' => __( 'Custom link target', 'aloom' ),
						'param_name' => 'custom_links_target',
						'description' => __( 'Select how to open custom links.', 'aloom' ),
						'dependency' => array(
							'element' => 'onclick',
							'value' => array( 'custom_link' )
						),
						'value' => $target_arr
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Slider speed', 'aloom' ),
						'param_name' => 'speed',
						'value' => '5000',
						'description' => __( 'Duration of animation between slides (in ms).', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Slides per view', 'aloom' ),
						'param_name' => 'slides_per_view',
						'value' => '1',
						'description' => __( 'Enter number of slides to display at the same time.', 'aloom' )
					),
					array(
						'type' => 'checkbox',
						'heading' => __( 'Auto Height', 'aloom' ),
						'param_name' => 'autoheight',
						'description' => __( 'Enable autoplay mode.', 'aloom' ),
						'value' => array( __( 'Yes', 'aloom' ) => 'yes' ),
					),
					array(
						'type' => 'checkbox',
						'heading' => __( 'Slider autoplay', 'aloom' ),
						'param_name' => 'autoplay',
						'description' => __( 'Enable autoplay mode.', 'aloom' ),
						'value' => array( __( 'Yes', 'aloom' ) => 'yes' ),
					),
					array(
						'type' => 'checkbox',
						'heading' => __( 'Lazyload', 'aloom' ),
						'param_name' => 'lazyload',
						'description' => __( 'If checked, images will be load late.', 'aloom' ),
						'value' => array( __( 'Yes', 'aloom' ) => 'yes' )
					),
					array(
						'type' => 'checkbox',
						'heading' => __( 'Hide pagination control', 'aloom' ),
						'param_name' => 'hide_pagination_control',
						'description' => __( 'If checked, pagination controls will be hidden.', 'aloom' ),
						'value' => array( __( 'Yes', 'aloom' ) => 'yes' )
					),
					array(
						'type' => 'checkbox',
						'heading' => __( 'Hide prev/next buttons', 'aloom' ),
						'param_name' => 'hide_prev_next_buttons',
						'description' => __( 'If checked, prev/next buttons will be hidden.', 'aloom' ),
						'value' => array( __( 'Yes', 'aloom' ) => 'yes' )
					),
					array(
						'type' => 'checkbox',
						'heading' => __( 'Slider loop', 'aloom' ),
						'param_name' => 'wrap',
						'description' => __( 'Enable slider loop mode.', 'aloom' ),
						'value' => array( __( 'Yes', 'aloom' ) => 'yes' )
					),
					array(
						'type' => 'checkbox',
						'heading' => __( 'Progress Bar', 'aloom' ),
						'param_name' => 'progressbar',
						'description' => __( 'Enable progress bar.', 'aloom' ),
						'value' => array( __( 'Yes', 'aloom' ) => 'yes' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'Extra class name', 'aloom' ),
						'param_name' => 'el_class',
						'description' => __( 'Style particular content element differently - add a class name and refer to it in custom CSS.', 'aloom' )
					),
					array(
						'type' => 'textfield',
						'heading' => __( 'ID Carousel', 'aloom' ),
						'param_name' => 'carousel_id',
						'description' => ''
					)
				)
			) );
			
			
		}
	}

}
      