<?php


/*
 *
 * Thanks for Leemason-NHP
 * Copyright (c) Options by Leemason-NHP 
 *
 * 
 * Require the framework class before doing anything else, so we can use the defined urls and dirs
 * Also if running on windows you may have url problems, which can be fixed by defining the framework url first
 *
 */
//define('king_options_URL', site_url('path the options folder'));
if(!class_exists('king_options')){
	global $king;
	locate_template( '/options/options.php', true );
}

/*
 * 
 * Custom function for filtering the sections array given by theme, good for child themes to override or add to the sections.
 * Simply include this function in the child themes functions.php file.
 *
 * NOTE: the defined constansts for urls, and dir will NOT be available at this point in a child theme, so you must use
 * get_template_directory_uri() if you want to use any of the built in icons
 *
 */
function add_another_section($sections){
	
	//$sections = array();
	$sections[] = array(
				'title' => __('A Section added by hook', 'aloom'),
				'desc' => __('<p class="description">This is a section created by adding a filter to the sections array, great to allow child themes, to add/remove sections from the options.</p>', 'aloom'),
				//all the glyphicons are included in the options folder, so you can hook into them, or link to your own custom ones.
				//You dont have to though, leave it blank for default.
				'icon' => trailingslashit(get_template_directory_uri()).'options/img/glyphicons/glyphicons_062_attach.png',
				//Lets leave this as a blank section, no options just some intro text set above.
				'fields' => array()
				);
	
	return $sections;
	
}//function

/*
 * 
 * Custom function for filtering the args array given by theme, good for child themes to override or add to the args array.
 *
 */
function change_framework_args($args){
	
	//$args['dev_mode'] = false;
	
	return $args;
	
}//function

/*
 * This is the meat of creating the optons page
 *
 * Override some of the default values, uncomment the args and change the values
 * - no $args are required, but there there to be over ridden if needed.
 *
 *
 */

function setup_framework_options(){
	
	global $king;
	
	$args = array();
	
	$args['dev_mode'] = false;
	
	$args['google_api_key'] = 'AIzaSyDAnjptHMLaO8exTHk7i8jYPLzygAE09Hg';
	
	$args['intro_text'] = __('<p>This is the HTML which can be displayed before the form, it isnt required, but more info is always better. Anything goes in terms of markup here, any HTML.</p>', 'aloom');
	
	$args['share_icons']['twitter'] = array(
											'link' => 'http://twitter.com/devnCo',
											'title' => 'Folow me on Twitter'
											);
	
	$args['show_import_export'] = false;
	
	$args['opt_name'] = KING_OPTNAME;
	
	$args['page_position'] = 1001;
	$args['allow_sub_menu'] = false;
	
	
	$import_file = dirname(__FILE__).DS.'sample'.DS.'data.xml';
	$import_html = '';		
	if ( file_exists($import_file) ){
	
		$import_html = '<h2></h2><br /><div class="nhp-opts-section-desc"><p class="description"><a style="font-style: normal;" href="admin.php?page=king-sample-data" class="btn btn_green">One-Click Importer Sample Data</a>  &nbsp; Just click and your website will look exactly our demo (posts, pages, menus, categories, tags, layouts, images, sliders, post-type) </p> <br /></div><hr style="background: #ccc;border: none;height: 1px;"/><br />';
		
	}	
	
	$sections = array();
	
	$patterns = array();
	for( $i=1; $i<13; $i++ ){
		$patterns['pattern'.$i.'.png'] = array('title' => 'Background '.$i, 'img' => THEME_URI.'/assets/images/elements/pattern'.$i.'.png');
	}
	for( $i=13; $i<17; $i++ ){
		$patterns['pattern'.$i.'.jpg'] = array('title' => 'Background '.$i, 'img' => THEME_URI.'/assets/images/elements/pattern'.$i.'-small.jpg');
	}
	
	$listHeaders = array();
	if ( $handle = opendir( THEME_PATH.DS.'templates'.DS.'header' ) ){
		while ( false !== ( $entry = readdir($handle) ) ) {
			if( $entry != '.' && $entry != '..' && strpos($entry, '.php') !== false  ){
				$title  = ucwords( str_replace( '-', ' ', basename( $entry, '.php' ) ) );
				$listHeaders[ $entry ] = array('title' => $title, 'img' => THEME_URI.'/templates/header/thumbnails/'.basename( $entry, '.php' ).'.jpg');
			}
		}
	}		

	$listFooters = array();
	if ( $handle = opendir( THEME_PATH.DS.'templates'.DS.'footer' ) ){
		while ( false !== ( $entry = readdir($handle) ) ) {
			if( $entry != '.' && $entry != '..' && strpos($entry, '.php') !== false  ){
				$title  = ucwords( str_replace( '-', ' ', basename( $entry, '.php' ) ) );
				$listFooters[ $entry ] = array('title' => $title, 'img' => THEME_URI.'/templates/footer/thumbnails/'.basename( $entry, '.php' ).'.jpg');
			}
		}
	}	
				
$sections[] = array(
	'icon' => king_options_URL.'img/glyphicons/glyphicons_023_cogwheels.png',
	'title' => __('General Settings', 'aloom'),
	'desc' => __('<p class="description">general configuration options for theme</p>', 'aloom'),
	'fields' => array(

		array(
			'id' => 'logo',
			'type' => 'upload',
			'title' => __('Upload Logo', 'aloom'), 
			'sub_desc' => __('This will be display as logo at header of every page', 'aloom'),
			'desc' => __('Upload new or from media library to use as your logo. We recommend that you use images without borders and throughout.', 'aloom'),
			'std' => THEME_URI.'/assets/images/logo.png'
		),
		array(
			'id' => 'logo_height',
			'type' => 'text',
			'title' => __('Logo Max Height', 'aloom'), 
			'sub_desc' => __('Limit logo\'s size. Eg: 60', 'aloom'),
			'std' => '50',
			'desc' => 'px',
			'css' => '<?php if($value!="")echo "html body .logo img{max-height: ".$value."px;}"; ?>',
		),		
		array(
			'id' => 'logo_top',
			'type' => 'text',
			'title' => __('Logo Top Spacing', 'aloom'), 
			'sub_desc' => __('The spacing from the logo to the edge of the page. Eg: 5', 'aloom'),
			'std' => '5',
			'desc' => 'px',
			'css' => '<?php if($value!="")echo "html body .logo{margin-top: ".$value."px;}"; ?>',
		),			
		array(
			'id' => 'favicon',
			'type' => 'upload',
			'title' => __('Upload Favicon', 'aloom'), 
			'std' => THEME_URI.'/favico.png',
			'sub_desc' => __('This will be display at title of browser', 'aloom'),
			'desc' => __('Upload new or from media library to use as your favicon.', 'aloom')
		),				
		array(
			'id' => 'layout',
			'type' => 'button_set',
			'title' => __('Select Layout', 'aloom'), 
			'desc' => '',
			'options' => array('wide' => 'WIDE','boxed' => 'BOXED'),
			'std' => 'wide'
		),
		array(
			'id' => 'responsive',
			'type' => 'button_set',
			'title' => __('Responsive Support', 'aloom'), 
			'desc' => __('Help display well on all screen size (smartphone, tablet, laptop, desktop...)', 'aloom'),
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'std' => '1'
		),		
		array(
			'id' => 'effects',
			'type' => 'button_set',
			'title' => __('Effects Lazy Load', 'aloom'), 
			'desc' => __('Sections\' effect displaying when scoll over.', 'aloom'),
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'std' => '1'
		),		
		array(
			'id' => 'admin_bar',
			'type' => 'button_set',
			'title' => __('Admin Bar', 'aloom'), 
			'desc' => __('The admin bar on top at Front-End when you logged in.', 'aloom'),
			'options' => array('hide' => 'Hide','show' => 'Show'),
			'std' => 'show'
		),
		array(
			'id' => 'smoother_scroll',
			'type' => 'button_set',
			'title' => __('Smooth Scroll Effect', 'aloom'), 
			'desc' => __('smoother effect when scrolling pages', 'aloom'),
			'options' => array('enable' => 'Enable','disable' => 'Disable'),
			'std' => 'disable'
		),
		array(
			'id' => 'breadcrumb',
			'type' => 'select',
			'title' => __('Show Breadcrumb', 'aloom'), 
			'desc' => __('The Breadcrumb on every page', 'aloom'),
			'options' => array(
				'page_title3 sty3' => 'Yes, Please!',
				'no' => 'No, Thanks!',
				'page_title2' => 'Page Title 2', 
				'page_title2 sty3' => 'Page Title 2 style 3', 
				'page_title2 sty4' => 'Page Title 2 style 4',
				'page_title2 sty5' => 'Page Title 2 style 5', 
				'page_title2 sty6' => 'Page Title 2 style 6', 
				'page_title2 sty7' => 'Page Title 2 style 7', 
				'page_title2 sty8' => 'Page Title 2 style 8', 
				'page_title2 sty9' => 'Page Title 2 style 9', 
				'page_title2 sty10' => 'Page Title 2 style 10', 
				'page_title3' => 'Page Title 3', 
				'page_title3 sty2' => 'Page Title 3 style 2',
				'page_title' => 'Page Title 3 style 3',
				'page_title3 sty4' => 'Page Title 3 style 4',
			),
			'std' => 'page_title'
		),
		array(
			'id' => 'breadeli',
			'type' => 'text',
			'title' => __('Breadcrumb Delimiter', 'aloom'), 
			'desc' => __('The symbol in beetwen your Breadcrumbs.', 'aloom'),
			'std' => '/'
		),
		array(
			'id' => 'breadcrumb_bg',
			'type' => 'upload',
			'title' => __('Breadcrumb Background Image', 'aloom'), 
			'desc' => __('Upload your background image for Breadcrumb', 'aloom'),
			'std' => '',
			'css' => '<?php if($value!="")echo "#breadcrumb.page_title1{background-image:url(".$value.");}"; ?>}'
		),		
		array(
			'id' => 'api_server',
			'type' => 'button_set',
			'title' => __('Select API Server', 'aloom'), 
			'desc' => __('Select API in case you have problems importing sample data or install sections', 'aloom'),
			'options' => array('api.devn.co' => 'API Server 1','api2.devn.co' => 'API Server 2'),
			'std' => 'api.devn.co'
		),
	)	
);

$sections[] = array(
	'icon' => king_options_URL.'img/glyphicons/glyphicons_263_bank.png',
	'title' => __('Header Settings', 'aloom'),
	'desc' => __('<p class="description">Select header & footer layouts, Add custom meta tags, hrefs and scripts to header.</p>', 'aloom'),
	'fields' => array(
		
		array(
			'id' => 'header',
			'type' => 'radio_img',
			'title' => __('Select Header', 'aloom'),
			'sub_desc' => '<br /><br />'.__('Overlap: The header will cover up anything beneath it. <br /> <br />Select header for all pages, You can also go to each page to select specific. This path has located /templates/header/__file__', 'aloom'),
			'options' => $listHeaders,
			'std' => 'default.php'
		),			
		array(
			'id' => 'topInfoEmail',
			'type' => 'text',
			'title' => __('Top Info Email', 'aloom'),
			'sub_desc' => __('Infomation email at top which will need for some of header layouts', 'aloom'),
			'std' => 'contact@king-theme.com'
		),		
		array(
			'id' => 'topInfoPhone',
			'type' => 'text',
			'title' => __('Top Info Phone', 'aloom'),
			'sub_desc' => __('Infomation phone at top which will need for some of header layouts', 'aloom'),
			'std' => '+1 123-456-78900'
		),
		array(
			'id' => 'minicartNav',
			'type' => 'button_set',
			'title' => __('Minicart in Menu', 'aloom'), 
			'desc' => __('Display minicart in right side of main menu (Only woocommerce is activated)', 'aloom'),
			'options' => array( 'show' => 'Show', 'hide' => 'Hide' ),
			'std' => 'show'
		),
		array(
			'id' => 'searchNav',
			'type' => 'button_set',
			'title' => __('Search box in Menu', 'aloom'), 
			'desc' => __('Display search in right side of main menu', 'aloom'),
			'options' => array( 'show' => 'Show', 'hide' => 'Hide' ),
			'std' => 'show'
		),
		array(
			'id' => 'header_social',
			'type' => 'button_set',
			'title' => __('Display Social Icons', 'aloom'), 
			'desc' => __('Display list of social icon and link on header - just for header support social icons', 'aloom'),
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),

	)
);
		
$sections[] = array(
	'icon' => king_options_URL.'img/glyphicons/glyphicons_303_temple_islam.png',
	'title' => __('Footer Settings', 'aloom'),
	'desc' => __('<p class="description">Select footer layouts, Add analytics embed..etc.. to footer</p>', 'aloom'),
	'fields' => array(
			
		array(
			'id' => 'footer',
			'type' => 'radio_img',
			'title' => __('Select Footer', 'aloom'),
			'sub_desc' => __('<br /><br />Select footer for all pages, You can also go to each page to select specific. This path has located /templates/footer/__file__', 'aloom'),
			'options' => $listFooters,
			'std' => 'default.php'
		),	
		array(
			'id' => 'footerTerms',
			'type' => 'text',
			'title' => __('Footer Terms\'s Link', 'aloom'), 
			'std' => '#'
		),
		array(
			'id' => 'footerPrivacy',
			'type' => 'text',
			'title' => __('Footer Privacy\'s Link', 'aloom'), 
			'std' => '#'
		),
		
	)
);		

$sections[] = array(
	'icon' => king_options_URL.'img/glyphicons/glyphicons_236_zoom_in.png',
	'title' => __('SEO', 'aloom'),
	'desc' => __('<p class="description">Help your site more friendly with Search Engine<br /> After active theme, we will enable all <strong>permalinks</strong> and meta descriptions.</p>', 'aloom'),
	'fields' => array(
		
		array(
			'id' => 'ogmeta',
			'type' => 'button_set',
			'title' => __('Open Graph Meta', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'std' => '1',
			'sub_desc' => __('elements that describe the object in different ways and are represented by meta tags included on the object page', 'aloom'),
		),
		array(
			'id' => 'metatag',
			'type' => 'button_set',
			'title' => __('Meta Tag', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'std' => '1',
			'sub_desc' => __('Show meta tags into head of website.', 'aloom'),
		),
		array(
			'id' => 'homeTitle',
			'type' => 'text',
			'title' => __('Homepage custom title', 'aloom'), 
			'desc' => __('<br />Default is:  <strong>%Site Title% - %Tagline%</strong> from General Settings', 'aloom'),
			'sub_desc' => __('The title will be displayed in homepage between &lt;title>&lt;/title> tags', 'aloom'),
		),	
		
		array(
			'id' => 'homeTitleFm',
			'type' => 'select',
			'title' => __('Home Title Format', 'aloom'), 
			'options' => array('1' => 'Blog Name | Blog description','2' => 'Blog description | Blog Name', '3' => 'Blog Name only'),
			'desc' => __('<br />If <b>Homepage custom title</b> not set', 'aloom'),
			'std' => '1'
		),		
		array(
			'id' => 'blogTitle',
			'type' => 'text',
			'title' => __('Blog page custom title', 'aloom'), 
			'desc' => wp_kses( __('<br />Support tags:  <strong>%Site Title%, %Tagline%</strong>', 'aloom'), array('br'=>array())),
			'sub_desc' => __('The title will be displayed in blog page between &lt;title>&lt;/title> tags', 'aloom'),
		),
		array(
			'id' => 'postTitleFm',
			'type' => 'select',
			'title' => __('Single Post Page Title Format', 'aloom'), 
			'options' => array('1' => 'Post title | Blog Name','2' => 'Blog Name | Post title', '3' => 'Post title only'),
			'std' => '1'
		),	
		
		array(
			'id' => 'archivesTitleFm',
			'type' => 'select',
			'title' => __('Archives Title Format', 'aloom'), 
			'options' => array('1' => 'Category name | Blog Name','2' => 'Blog Name | Category name', '3' => 'Category name only'),
			'std' => '1'
		),
		
		array(
			'id' => 'titleSeparate',
			'type' => 'text',
			'title' => __('Separate Character', 'aloom'), 
			'sub_desc' => __('a Character to separate BlogName and Post title', 'aloom'),
			'std' => '|'
		),			
		
		array(
			'id' => 'homeMetaKeywords',
			'type' => 'textarea',
			'title' => __('Home Meta Keywords', 'aloom'), 
			'sub_desc' => __('Add  tags for the search engines and especially Google', 'aloom'),
		),			
		array(
			'id' => 'homeMetaDescription',
			'type' => 'textarea',
			'title' => __('Home Meta Description', 'aloom'), 

		),			
		array(
			'id' => 'authorMetaKeywords',
			'type' => 'textarea',
			'title' => __('Author Meta Description', 'aloom'), 
			'std' => 'king-theme.com'
		),		
		array(
			'id' => 'contactMetaKeywords',
			'type' => 'textarea',
			'title' => __('Contact Meta Description', 'aloom'), 
			'std' => 'contact@king-theme.com'
		),		
		array(
			'id' => 'otherMetaKeywords',
			'type' => 'textarea',
			'title' => __('Other Page Meta Keywords', 'aloom'), 

		),			
		array(
			'id' => 'otherMetaDescription',
			'type' => 'textarea',
			'title' => __('Other Page Meta Description', 'aloom'), 

		),	
	)

);


$sections[] = array(
	'icon' => king_options_URL.'img/glyphicons/glyphicons_087_log_book.png',
	'title' => __('Blog', 'aloom'),
	'desc' => __('Blog Settings', 'aloom'),	
	'fields' => array(
		array(
			'id' => 'blog',
			'type' => 'blog'
		)
	)
);


$sections[] = array(
	'icon' => king_options_URL.'img/glyphicons/glyphicons_061_keynote.png',
	'title' => __('Article Settings', 'aloom'),
	'desc' => __('<p class="description">Settings for Single post or Page</p>', 'aloom'),
	'fields' => array(
		array(
			'id' => 'excerptImage',
			'type' => 'button_set',
			'title' => __('Featured Image', 'aloom'), 
			'sub_desc' => __('Display Featured image before of content', 'aloom'),
			'options' => array('1' => 'Display','2' => 'Hide'),
			'std' => '1'
		),		
		array(
			'id' => 'navArticle',
			'type' => 'button_set',
			'title' => __('Next/Prev Article Direction', 'aloom'), 
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),
		array(
			'id' => 'showMeta',
			'type' => 'button_set',
			'title' => __('Meta Box', 'aloom'), 
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),
		array(
			'id' => 'showAuthorMeta',
			'type' => 'button_set',
			'title' => __('Author Meta', 'aloom'), 
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),
		array(
			'id' => 'showDateMeta',
			'type' => 'button_set',
			'title' => __('Date Meta', 'aloom'), 
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),
		array(
			'id' => 'showCateMeta',
			'type' => 'button_set',
			'title' => __('Categories Meta', 'aloom'), 
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),
		array(
			'id' => 'showCommentsMeta',
			'type' => 'button_set',
			'title' => __('Comments Meta', 'aloom'), 
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),
		array(
			'id' => 'showTagsMeta',
			'type' => 'button_set',
			'title' => __('Tags Meta', 'aloom'), 
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),
		array(
			'id' => 'showShareBox',
			'type' => 'button_set',
			'title' => __('Share Box', 'aloom'), 
			'sub_desc' => __('Display box socials button below', 'aloom'),
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),
		array(
			'id' => 'showShareFacebook',
			'type' => 'button_set',
			'title' => __('Facebook Button', 'aloom'), 
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),
		array(
			'id' => 'showShareTwitter',
			'type' => 'button_set',
			'title' => __('Tweet Button', 'aloom'), 
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),
		array(
			'id' => 'showShareGoogle',
			'type' => 'button_set',
			'title' => __('Google Button', 'aloom'), 
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),
		array(
			'id' => 'showSharePinterest',
			'type' => 'button_set',
			'title' => __('Pinterest Button', 'aloom'), 
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),
		array(
			'id' => 'showShareLinkedin',
			'type' => 'button_set',
			'title' => __('LinkedIn Button', 'aloom'), 
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),
		array(
			'id' => 'archiveAboutAuthor',
			'type' => 'button_set',
			'title' => __('About Author', 'aloom'), 
			'options' => array('1' => 'Show','0' => 'Hide'),
			'sub_desc' => __('About author box with avatar and description', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'archiveRelatedPosts',
			'type' => 'button_set',
			'title' => __('Related Posts', 'aloom'), 
			'options' => array('1' => 'Show','0' => 'Hide'),
			'sub_desc' => __('List related posts after the content.', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'archiveNumberofPosts',
			'type' => 'text',
			'title' => __('Number of posts related to show', 'aloom'), 
			'validate' => 'numeric',
			'std' => '3'
		),
		array(
			'id' => 'archiveRelatedQuery',
			'type' => 'button_set',
			'title' => __('Related Query Type', 'aloom'), 
			'options' => array('category' => 'Category','tag' => 'Tag','author'=>'Author'),
			'std' => 'category'
		)
	)

);

$sections[] = array('divide'=>true);	


$sections[] = array(
	'icon' => king_options_URL.'img/glyphicons/glyphicons_037_credit.png',
	'title' => __('Dynamic Sidebars', 'aloom'),
	'desc' => __('You can create unlimited sidebars and use it in any page you want.','aloom'),
	'fields' => array(
		array(
			'id' => 'sidebars',
			'type' => 'multi_text',
			'title' => __('List of Sidebars Created', 'aloom'),
			'sub_desc' => __('Add name of sidebar', 'aloom'),
			'std' => array('Nav Sidebar')
		),
	)

);
 
$sections[] = array(
	'icon' => king_options_URL.'img/glyphicons/glyphicons_273_drink.png',
	'title' => __('Styling', 'aloom'),
	'desc' => __('<p class="description">Setting up global style and background</p>', 'aloom'),
	'fields' => array(
		array(
			'id' => 'colorStyle',
			'type' => 'colorStyle',
			'title' => __('Color Style', 'aloom'), 
			'sub_desc' => __('Predefined Color Skins', 'aloom'),
			'desc' => __( 'Primary css file has been located at: /wp_content/themes/__name__/assets/css/colors/color-primary.css', 'aloom' ),
			'std'	=> ''
		),
		array(
			'type' => 'color',
			'id' => 'backgroundColor',
			'title' =>  __('Background Color', 'aloom'),
			'desc' =>  __(' Background body for layout wide and background box for layout boxed', 'aloom'), 
			'css' => '<?php if($value!="")echo "body{background-color: ".$value.";}"; ?>',
			'std' => '#f0f0f0'
		),	
		array(
			'type' => 'upload',
			'id' => 'backgroundCustom',
			'title' =>  __('Custom Background Image', 'aloom'),
			'sub_desc' => __('Only be used for Boxed Type.', 'aloom'),
			'desc' =>  __(' Upload your custom background image, or you can also use the Pattern available below.', 'aloom'),
			'std' => '',
			'css' => '<?php if($value!="")echo "body{background-image: url(".$value.") !important;}"; ?>'
		
		),
		array(
			'id' => 'useBackgroundPattern',
			'type' => 'checkbox_hide_below',
			'title' => __('Use Pattern for background', 'aloom'), 
			'sub_desc' => __('Tick on checkbox to show list of Patterns', 'aloom'),
			'desc' => __('If you do not have background image, you can also use our Pattern.', 'aloom'),
			'std' => 0,
		),
		array(
			'id' => 'backgroundImage',
			'type' => 'radio_img',
			'title' => __('Select background', 'aloom'), 
			'sub_desc' => __('Only be used for Boxed Type.', 'aloom'),
			'options' => $patterns,
			'std' => '',
			'css' => '<?php if($value!="")echo "body{background-image: url('.THEME_URI.'/assets/images/elements/".$value.");}"; ?>'
		),		
		array(
			'id' => 'linksDecoration',
			'type' => 'select',
			'title' => __('Links Decoration', 'aloom'), 
			'sub_desc' => __('Set decoration for all links.', 'aloom'),
			'options' => array('default'=>'Default','none'=>'None','underline'=>'Underline','overline'=>'Overline','line-through'=>'Line through'),
			'std' => 'default',
			'css' => '<?php if($value!="")echo "a{text-decoration: ".$value.";}"; ?>'
		),		
		array(
			'id' => 'linksHoverDecoration',
			'type' => 'select',
			'title' => __('Links Hover Decoration', 'aloom'), 
			'sub_desc' => __('Set decoration for all links when hover.', 'aloom'),
			'options' => array('default'=>'Default','none'=>'None','underline'=>'Underline','overline'=>'Overline','line-through'=>'Line through'),
			'std' => 'default',
			'css' => '<?php if($value!="")echo "a:hover{text-decoration: ".$value.";}"; ?>'
		),		
		array(
			'id' => 'cssGlobal',
			'type' => 'textarea',
			'title' => __('Global CSS', 'aloom'), 
			'sub_desc' => __('CSS for all screen size, only CSS without &lt;style&gt; tag', 'aloom'),
			'css' => '<?php if($value!="")print( $value ); ?>'
		),
		array(
			'id' => 'cssTablets',
			'type' => 'textarea',
			'title' => __('Tablets CSS', 'aloom'), 
			'sub_desc' => __('Width from 768px to 985px, only CSS without &lt;style&gt; tag', 'aloom'),
			'css' => '<?php if($value!="")echo "@media (min-width: 768px) and (max-width: 985px){".$value."}"; ?>'
		),
		array(
			'id' => 'cssPhones',
			'type' => 'textarea',
			'title' => __('Wide Phones CSS', 'aloom'), 
			'sub_desc' => __('Width from 480px to 767px, only CSS without &lt;style&gt; tag', 'aloom'),
			'css' => '<?php if($value!="")echo "@media (min-width: 480px) and (max-width: 767px){".$value."}"; ?>'
		),
		
	)

);

$sections[] = array(
	'icon' => king_options_URL.'img/glyphicons/glyphicons_107_text_resize.png',
	'title' => __('Typography', 'aloom'),
	'desc' => __('<p class="description">Set the color, font family, font size, font weight and font style.</p>', 'aloom'),
	'fields' => array(
		array(
			'id' => 'generalTypography',
			'type' => 'typography',
			'title' => __('General Typography', 'aloom'), 
			'std' => array(),
			'css' => 'body,.dropdown-menu,body p{<?php if($value[color]!="")echo "color:".$value[color].";"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\';"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),				
		array(
			'id' => 'generalHoverTypography',
			'type' => 'typography',
			'title' => __('General Link Hover', 'aloom'), 
			'css' => 'body * a:hover, body * a:active, body * a:focus{<?php if($value[color]!="")echo "color:".$value[color]." !important;"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\';"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),		
		array(
			'id' => 'mainMenuTypography',
			'type' => 'typography',
			'title' => __('Main Menu', 'aloom'),
			'css' => 'body .navbar-default .navbar-nav>li>a{<?php if($value[color]!="")echo "color:".$value[color].";"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\' !important;"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight]." !important;"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),		
		array(
			'id' => 'mainMenuHoverTypography',
			'type' => 'typography',
			'title' => __('Main Menu Hover', 'aloom'), 
			'css' => 'body .navbar-default .navbar-nav>li>a:hover,.navbar-default .navbar-nav>li.current-menu-item>a{<?php if($value[color]!="")echo "color:".$value[color]." !important;"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\' !important;"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),			
		array(
			'id' => 'mainMenuSubTypography',
			'type' => 'typography',
			'title' => __('Sub Main Menu', 'aloom'), 
			'css' => '.dropdown-menu>li>a{<?php if($value[color]!="")echo "color:".$value[color].";"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\';"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),			
		array(
			'id' => 'mainMenuSubHoverTypography',
			'type' => 'typography',
			'title' => __('Sub Main Menu Hover', 'aloom'), 
			'css' => '.dropdown-menu>li>a:hover{<?php if($value[color]!="")echo "color:".$value[color]." !important;"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\';"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),	
		array(
			'id' => 'postMetaTypography',
			'type' => 'typography',
			'title' => __('Post Meta', 'aloom'), 
			'std' => array(),
			'css' => '.post_meta_links{<?php if($value[color]!="")echo "color:".$value[color].";"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\';"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),
		array(
			'id' => 'postMatalinkTypography',
			'type' => 'typography',
			'title' => __('Post Meta Link', 'aloom'), 
			'css' => '.post_meta_links li a{<?php if($value[color]!="")echo "color:".$value[color].";"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\';"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),
		array(
			'id' => 'postTitleTypography',
			'type' => 'typography',
			'title' => __('Post Title', 'aloom'), 
			'css' => '.blog_post h3.entry-title a{<?php if($value[color]!="")echo "color:".$value[color].";"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\';"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),
		array(
			'id' => 'postEntryTypography',
			'type' => 'typography',
			'title' => __('Post Entry', 'aloom'), 
			'css' => 'article .blog_postcontent,article .blog_postcontent p{<?php if($value[color]!="")echo "color:".$value[color].";"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\';"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),
		array(
			'id' => 'widgetTitlesTypography',
			'type' => 'typography',
			'title' => __('Widget Titles', 'aloom'),
			'css' => 'h3.widget-title,#reply-title,#comments-title{<?php if($value[color]!="")echo "color:".$value[color].";"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\';"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),
		array(
			'id' => 'footerWidgetTitlesTypography',
			'type' => 'typography',
			'title' => __('Footer Widgets Titles', 'aloom'), 
			'std'	=> array(),
			'css' => '.footer h3.widget-title{<?php if($value[color]!="")echo "color:".$value[color].";"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\';"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),
		array(
			'id' => 'h1Typography',
			'type' => 'typography',
			'title' => __('H1 Typography', 'aloom'), 
			'std' => array(),
			'css' => '.entry-content h1{<?php if($value[color]!="")echo "color:".$value[color].";"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\';"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),
		array(
			'id' => 'h2Typography',
			'type' => 'typography',
			'title' => __('H2 Typography', 'aloom'), 
			'std' => array(),
			'css' => '.entry-content h2{<?php if($value[color]!="")echo "color:".$value[color].";"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\';"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),
		array(
			'id' => 'h3Typography',
			'type' => 'typography',
			'title' => __('H3 Typography', 'aloom'), 
			'std' => array(),
			'css' => '.entry-content h3{<?php if($value[color]!="")echo "color:".$value[color].";"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\';"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),
		array(
			'id' => 'h4Typography',
			'type' => 'typography',
			'title' => __('H4 Typography', 'aloom'), 
			'std' => array(),
			'css' => '.entry-content h4{<?php if($value[color]!="")echo "color:".$value[color].";"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\';"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),
		array(
			'id' => 'h5Typography',
			'type' => 'typography',
			'title' => __('H5 Typography', 'aloom'), 
			'std' => array(),
			'css' => '.entry-content h5{<?php if($value[color]!="")echo "color:".$value[color].";"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\';"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		),
		array(
			'id' => 'h6Typography',
			'type' => 'typography',
			'title' => __('H6 Typography', 'aloom'), 
			'std' => array(),
			'css' => '.entry-content h6{<?php if($value[color]!="")echo "color:".$value[color].";"; ?><?php if($value[font]!="")echo "font-family:\'".$value[font]."\';"; ?><?php if($value[size]!="")echo "font-size:".$value[size]."px;"; ?><?php if($value[weight]!="")echo "font-weight:".$value[weight].";"; ?><?php if($value[style]!="")echo "font-style:".$value[style].";"; ?>}'
		)
		
	)

);


$sections[] = array(
	'icon' => king_options_URL.'img/glyphicons/glyphicons_050_link.png',
	'title' => __('Social Accounts', 'aloom'),
	'desc' => __('Set your socials and will be displayed icons at header and footer, Leave blank to hide icons from front-end', 'aloom'),
	'fields' => array(
		array(
			'id' => 'feed',
			'type' => 'text',
			'title' => __('Your Feed RSS', 'aloom'),
			'sub_desc' => __('Enter full link e.g: http://yoursite.com/feed', 'aloom'),
			'std' => 'feed'
		),
		array(
			'id' => 'facebook',
			'type' => 'text',
			'title' => __('Your Facebook Account', 'aloom'),
			'sub_desc' => __('Social icon will not display if you leave empty', 'aloom'),
			'std' => 'king'
		),
		array(
			'id' => 'twitter',
			'type' => 'text',
			'title' => __('Your Twitter Account', 'aloom'),
			'sub_desc' => __('Social icon will not display if you leave empty', 'aloom'),
			'std' => 'king'
		),
		array(
			'id' => 'google',
			'type' => 'text',
			'title' => __('Your Google+ Account', 'aloom'),
			'sub_desc' => __('Social icon will not display if you leave empty', 'aloom'),
			'std' => 'king'
		),
		array(
			'id' => 'linkedin',
			'type' => 'text',
			'title' => __('Your LinkedIn Account', 'aloom'),
			'sub_desc' => __('Social icon will not display if you leave empty', 'aloom'),
			'std' => 'king'
		),
		array(
			'id' => 'flickr',
			'type' => 'text',
			'title' => __('Your Flickr Account', 'aloom'),
			'sub_desc' => __('Social icon will display if you leave empty', 'aloom'),
			'std' => 'king'
		),
		array(
			'id' => 'pinterest',
			'type' => 'text',
			'title' => __('Your Pinterest Account', 'aloom'),
			'sub_desc' => __('Social icon will not display if you leave empty', 'aloom'),
			'std' => 'king'
		),
		array(
			'id' => 'instagram',
			'type' => 'text',
			'title' => __('Your Instagram Account', 'aloom'),
			'sub_desc' => __('Social icon will not display if you leave empty', 'aloom'),
			'std' => 'king'
		),
		array(
			'id' => 'youtube',
			'type' => 'text',
			'title' => __('Your Youtube Chanel', 'aloom'),
			'sub_desc' => __('Social icon will not display if you leave empty', 'aloom'),
			'std' => 'king'
		)
		
	)

);


//  coming soon

$sections[] = array(
	'icon' => king_options_URL.'img/glyphicons/glyphicons_022_fire.png',
	'title' => __('Coming soon', 'aloom'),
	'desc' => __('Set your socials and will be displayed icons at header and footer, Leave blank to hide icons from front-end', 'aloom'),
	'fields' => array(
		array(
			'id' => 'cs_logo',
			'type' => 'upload',
			'title' => __('Upload Logo', 'aloom'), 
			'sub_desc' => __('This will be display as logo at header of every page', 'aloom'),
			'desc' => __('Upload new or from media library to use as your logo. We recommend that you use images without borders and throughout.', 'aloom'),
			'std' => THEME_URI.'/assets/images/logo.png'
		),
		array(
			'id' => 'cs_text_after_logo',
			'type' => 'text',
			'title' => __('Text after logo', 'aloom'),
			'sub_desc' => __('Will show "We\'re Launching Soon" if you leave empty', 'aloom'),
			'std' => 'We\'re Launching Soon'
		),
		array(
			'id' => 'cs_timedown',
			'type' => 'text',
			'title' => __('Date time for countdown', 'aloom'),
			'sub_desc' => __('Format  "F d, Y H:i:s" for example "October 18, 2015 08:30:30"', 'aloom'),
			'std' => 'October 18, 2025 08:30:30'
		),
		array(
			'id' => 'cs_description',
			'type' => 'textarea',
			'title' => __('Description', 'aloom'), 
			'std' => 'Our website is under construction. We\'ll be here soon with our new awesome site. Get best experience with this one.'
		),
		array(
			'id' => 'cs_slider1',
			'type' => 'upload',
			'title' => __('Background Slider image 1', 'aloom'), 
			'sub_desc' => __('This will be display as slide at coming soon slider ', 'aloom'),
			'desc' => __('', 'aloom'),
			'std' => ''
		),
		array(
			'id' => 'cs_slider2',
			'type' => 'upload',
			'title' => __('Background Slider image 2', 'aloom'), 
			'sub_desc' => __('This will be display as slide at coming soon slider ', 'aloom'),
			'desc' => __('', 'aloom'),
			'std' => ''
		),
		array(
			'id' => 'cs_slider3',
			'type' => 'upload',
			'title' => __('Background Slider image 3', 'aloom'), 
			'sub_desc' => __('This will be display as slide at coming soon slider ', 'aloom'),
			'desc' => __('', 'aloom'),
			'std' => ''
		),
		array(
			'id' => 'cs_slider4',
			'type' => 'upload',
			'title' => __('Background Slider image 4', 'aloom'), 
			'sub_desc' => __('This will be display as slide at coming soon slider ', 'aloom'),
			'desc' => __('', 'aloom'),
			'std' => ''
		),
		array(
			'id' => 'cs_slider5',
			'type' => 'upload',
			'title' => __('Background Slider image 5', 'aloom'), 
			'sub_desc' => __('This will be display as slide at coming soon slider ', 'aloom'),
			'desc' => __('', 'aloom'),
			'std' => ''
		),
		
	)

);




//  Post Types
$sections[] = array(
	'icon' => king_options_URL.'img/glyphicons/glyphicons_145_folder_plus.png',
	'title' => __('Custom Post Types', 'aloom'),
	'desc' => __('Setting title, slugs for post types', 'aloom'),
	'fields' => array(
		array(
			'id' => 'our_works_title',
			'type' => 'text',
			'title' => __('Our Works Title', 'aloom'), 
			'sub_desc' => __('This will replace \'Our Works\' menu, breadcrumb text', 'aloom'),
			'desc' => __('', 'aloom'),
			'std' => ''
		),
		array(
			'id' => 'our_works_slug',
			'type' => 'text',
			'title' => __('Our Works Slug', 'aloom'), 
			'sub_desc' => __('This will replace /our-works/ on url', 'aloom'),
			'desc' => __('', 'aloom'),
			'std' => ''
		),
		array(
			'id' => 'our_works_show_link',
			'type' => 'button_set',
			'title' => __('Our Work Read More Links', 'aloom'), 
			'sub_desc' => __('Show/Hiden read more link on projects page', 'aloom'),
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),
		array(
			'id' => 'our_works_show_category',
			'type' => 'button_set',
			'title' => __('Our Work Category Links', 'aloom'), 
			'sub_desc' => __('Show/Hiden categories link on project details page', 'aloom'),
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),
		array(
			'id' => 'our_works_visit_link',
			'type' => 'button_set',
			'title' => __('Our Work Visit Site Link', 'aloom'), 
			'sub_desc' => __('Show/Hiden Viset Site link on project detail page', 'aloom'),
			'options' => array('1' => 'Show','0' => 'Hide'),
			'std' => '1'
		),		
		array(
			'id' => 'our_team_title',
			'type' => 'text',
			'title' => __('Our Team Title', 'aloom'), 
			'sub_desc' => __('This will replace \'Our Team\' menu, breadcrumb text', 'aloom'),
			'desc' => __('', 'aloom'),
			'std' => ''
		),
		array(
			'id' => 'our_team_slug',
			'type' => 'text',
			'title' => __('Our Team Slug', 'aloom'), 
			'sub_desc' => __('This will replace /our-team/ on url', 'aloom'),
			'desc' => __('', 'aloom'),
			'std' => ''
		),		
		array(
			'id' => 'faq_title',
			'type' => 'text',
			'title' => __('FAQ Title', 'aloom'), 
			'sub_desc' => __('This will replace \'FAQ\' menu, breadcrumb text', 'aloom'),
			'desc' => __('', 'aloom'),
			'std' => ''
		),
		array(
			'id' => 'faq_slug',
			'type' => 'text',
			'title' => __('FAQ Slug', 'aloom'), 
			'sub_desc' => __('This will replace /faq/ on url', 'aloom'),
			'desc' => __('', 'aloom'),
			'std' => ''
		),	
	)

);


$sections[] = array('divide'=>true);	
	

//  Woo Admin
$sections[] = array(
	'icon' => king_options_URL.'img/glyphicons/glyphicons_202_shopping_cart.png',
	'title' => __('WooEcommerce', 'aloom'),
	'desc' => __('Setting for your Shop!', 'aloom'),
	'fields' => array(
		array(
			'id' => 'product_number',
			'type' => 'text',
			'title' => __('Number of Products per Page', 'aloom'),
			'desc' => __('Insert the number of products to display per page.', 'aloom'),
			'std' => '12'
		),
		array(
			'id' => 'woo_grids',
			'type' => 'select',
			'title' => __('Items per row', 'aloom'), 
			'desc' => __('Set number products per row (for Grids layout)', 'aloom'),
			'options' => array('4'=>'4 (Shop layout without sidebar)','3'=>'3 (Shop layout with sidebar)'),
			'std' => '3'
		),			
		array(
			'id' => 'woo_layout',
			'type' => 'select',
			'title' => __('Shop Layout', 'aloom'), 
			'desc' => __('Set layout for your shop page.', 'aloom'),
			'options' => array('full'=>'No sidebar - Full width', 'left'=>'With Sidebar on Left', 'right'=>'With Sidebar on Right'),
			'std' => 'left'
		),		
		array(
			'id' => 'woo_product_layout',
			'type' => 'select',
			'title' => __('Product Layout', 'aloom'), 
			'desc' => __('Set layout for your product detail page.', 'aloom'),'options' => array('full'=>'No sidebar - Full width', 'left'=>'With Sidebar on Left', 'right'=>'With Sidebar on Right'),
			'std' => 'right'
		),	
		array(
			'id' => 'woo_product_display',
			'type' => 'select',
			'title' => __('Product Display', 'aloom'), 
			'desc' => __('Display products by grid or list.', 'aloom'),
			'options' => array('grid'=>'Grid','list'=>'List'),
			'std' => 'grid'
		),	
		array(
			'id' => 'woo_filter',
			'type' => 'button_set',
			'title' => __('Filter Products', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Enable filter products by price, categories, attributes..', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'woo_cart',
			'type' => 'button_set',
			'title' => __('Show Woocommerce Cart Icon in Top Menu', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Enable Woocommerce Cart show on top menu', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'woo_social',
			'type' => 'button_set',
			'title' => __('Show Woocommerce Social Icons', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Show Woocommerce Social Icons in Single Product Page', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'woo_message_1',
			'type' => 'textarea',
			'title' => __('Account Message 1', 'aloom'), 
			'desc' => __('Insert your message to appear in the first message box on the acount page.', 'aloom'),
			'std' => 'Call us in 000-000-000 If you need our support. Happy to help you !'
		),
		array(
			'id' => 'woo_message_2',
			'type' => 'textarea',
			'title' => __('Account Message 2', 'aloom'), 
			'desc' => __('Insert your message to appear in the second message box on the acount page.', 'aloom'),
			'std' => 'Send us a email in devn@support.com'
		),
		
	)

);
// Woo Compare Products
$sections[] = array(
	'icon' => king_options_URL.'img/glyphicons/compare.png',
	'title' => __('Compare Products', 'aloom'),
	'desc' => __('Setting compare product features!', 'aloom'),
	'fields' => array(
		array(
			'id' => 'woo_comp_active',
			'type' => 'button_set',
			'title' => __('Compare Products Active', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Enable compare product feature.', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'woo_comp_button',
			'type' => 'select',
			'title' => __('Link or Button', 'aloom'), 
			'desc' => __('Set link or button compare products.', 'aloom'),
			'options' => array( 'button' =>'Button','link'=>'Link'),
			'std' => 'button'
		),	
		array(
			'id' => 'woo_comp_button_label',
			'type' => 'text',
			'title' => __('Link/Button label', 'aloom'),
			'desc' => __('Set label for compare button/link.', 'aloom'),
			'std' => 'Compare'
		),
		array(
			'id' => 'woo_comp_single',
			'type' => 'button_set',
			'title' => __('Show button in single product page', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __(' Enable to show the button in the single product page.', 'aloom'),
			'std' => '1',
			'default' => '1'
		),
		array(
			'id' => 'woo_comp_pos_list',
			'type' => 'button_set',
			'title' => __('Show button in products list', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __(' Enable to show the button in the list product page.', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'woo_comp_lightbox',
			'type' => 'button_set',
			'title' => __('Compare lightbox', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Pop-up lightbox when click to compare button.', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'woo_comp_table_title',
			'type' => 'text',
			'title' => __('Compare table title', 'aloom'),
			'desc' => __('Set title for comparison table.', 'aloom'),
			'std' => 'Compare products'
		),
		array(
			'id' => 'woo_comp_p_title',
			'type' => 'button_set',
			'title' => __('Title', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Display product title in comparison table.', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'woo_comp_p_image',
			'type' => 'button_set',
			'title' => __('Image', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Display product image in comparison table.', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'woo_comp_p_price',
			'type' => 'button_set',
			'title' => __('Price', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Display product price in comparison table.', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'woo_comp_p_des',
			'type' => 'button_set',
			'title' => __('Description', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Display description in comparison table.', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'woo_comp_p_stock',
			'type' => 'button_set',
			'title' => __('In Stock', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Display "In Stock" in comparison table.', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'woo_comp_p_attribute',
			'type' => 'button_set',
			'title' => __('Attributes', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Display attributes were created for products ( color, size, etc... ).', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'woo_comp_p_addtc',
			'type' => 'button_set',
			'title' => __('Add to cart', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Display add to cart in comparison table.', 'aloom'),
			'std' => '1'
		),	
		array(
			'id' => 'woo_comp_image_width',
			'type' => 'text',
			'title' => __('Image width', 'aloom'),
			'desc' => __('Set width for product image (px).', 'aloom'),
			'std' => '220'
		),
		array(
			'id' => 'woo_comp_image_height',
			'type' => 'text',
			'title' => __('Image height', 'aloom'),
			'desc' => __('Set height for product image (px).', 'aloom'),
			'std' => '154'
		),
		array(
			'id' => 'woo_comp_i_crop',
			'type' => 'button_set',
			'title' => __('Image hard crop', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Hard crop product image in comparision table.', 'aloom'),
			'std' => '1'
		)
		
	)

);
// Woo Magnifier
$sections[] = array(
	'icon' => king_options_URL.'img/glyphicons/glyphicons_027_search.png',
	'title' => __('Woo Magnifier', 'aloom'),
	'desc' => __('Setting Magnifier effect for images product in single product page!', 'aloom'),
	'fields' => array(
		array(
			'id' => 'mg_active',
			'type' => 'button_set',
			'title' => __('Magnifier Active', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Enable magnifier for product images/ Disable magnifier to use default lightbox for product images', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'mg_zoom_width',
			'type' => 'text',
			'title' => __('Zoom Width', 'aloom'),
			'desc' => __('Set width of magnifier box ( default: auto )', 'aloom'),
			'std' => 'auto'
		),
		array(
			'id' => 'mg_zoom_height',
			'type' => 'text',
			'title' => __('Zoom Height', 'aloom'),
			'desc' => __('Set height of magnifier box ( default: auto )', 'aloom'),
			'std' => 'auto'
		),
		array(
			'id' => 'mg_zoom_position',
			'type' => 'select',
			'title' => __('Zoom Position', 'aloom'), 
			'desc' => __('Set magnifier position ( default: Right )', 'aloom'),
			'options' => array('right'=>'Right','inside'=>'Inside'),
			'std' => 'right'
		),	
		array(
			'id' => 'mg_zoom_position_mobile',
			'type' => 'select',
			'title' => __('Zoom Position on Mobile', 'aloom'), 
			'desc' => __('Set magnifier position on mobile devices (iPhone, Android, etc.)', 'aloom'),
			'options' => array('default'=>'Default','inside'=>'Inside','disable'=>'Disable'),
			'std' => 'default'
		),	
		array(
			'id' => 'mg_loading_label',
			'type' => 'text',
			'title' => __('Loading Label', 'aloom'),
			'desc' => __('Set text for magnifier loading...', 'aloom'),
			'std' => 'Loading...'
		),
		array(
			'id' => 'mg_lens_opacity',
			'type' => 'text',
			'title' => __('Lens Opacity', 'aloom'),
			'desc' => __('Set opacity for Lens (0 - 1)', 'aloom'),
			'std' => '0.5'
		),
		array(
			'id' => 'mg_blur',
			'type' => 'button_set',
			'title' => __('Blur Effect', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Blur effect when Lens hover on product images', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'mg_thumbnail_slider',
			'type' => 'button_set',
			'title' => __('Active Slider', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Enable slider for product thumbnail images', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'mg_slider_item',
			'type' => 'text',
			'title' => __('Items', 'aloom'),
			'desc' => __('Number items of Slide', 'aloom'),
			'default' => 3
		),
		array(
			'id' => 'mg_thumbnail_circular',
			'type' => 'button_set',
			'title' => __('Circular Thumbnail', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Continue slide as a circle', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'mg_thumbnail_infinite',
			'type' => 'button_set',
			'title' => __('Infinite Thumbnail', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Back to first image when end of list', 'aloom'),
			'std' => '1'
		),
		
		
		
		
	)

);

// Woo Wishlist

$sections[] = array(
	'icon' => king_options_URL.'img/glyphicons/glyphicons_012_heart.png',
	'title' => __('Woo WishList', 'aloom'),
	'desc' => __('Setting Wishlist features for your Shop page!', 'aloom'),
	'fields' => array(
		array(
			'id' => 'wl_actived',
			'type' => 'button_set',
			'title' => __('WishList Active', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Enable WishList features. Be sure that the wishlist page is selected in Admin > Pages Manager', 'aloom'),
			'std' => '1',
			'default' => '1'
		),
		array(
			'id' => 'wl_cookies',
			'type' => 'button_set',
			'title' => __('Cookies Enable', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Use cookies instead of sessions. If cookies actived, the wishlist will be available for each not logged user for 30 days. Use the filter king_wcwl_cookie_expiration_time to change the expiration time ( needs timestamp ).', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'wl_title',
			'type' => 'text',
			'title' => __('WishList Title', 'aloom'),
			'desc' => __('Set WishList page Title for your Shop', 'aloom'),
			'std' => 'My Wishlist on '.THEME_NAME.' Shop'
		),
		array(
			'id' => 'wl_label',
			'type' => 'text',
			'title' => __('Add to cart label', 'aloom'),
			'desc' => __('Set label for add to cart button in WishList page.', 'aloom'),
			'std' => 'Add to Cart'
		),
		array(
			'id' => 'wl_w_label',
			'type' => 'text',
			'title' => __('Add to wishlist label', 'aloom'),
			'desc' => __('Set label for add to wishlist button in WishList page.', 'aloom'),
			'std' => 'Add to wishlist'
		),
		array(
			'id' => 'wl_position',
			'type' => 'select',
			'title' => __('Position', 'aloom'), 
			'desc' => __('Set Wishlist position ( default: After Add to Cart )', 'aloom'),
			'options' => array( 'after-cart' =>'After "Add to cart"','after-thumbnails'=>'After thumbnails', 'after-summary'=>'After summary', 'use-shortcode' => 'Use shortcode'),
			'std' => 'after-cart'
		),	
		
		array(
			'id' => 'wl_redirect',
			'type' => 'button_set',
			'title' => __('Redirect to Cart page', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Go to Cart page if user click "Add to cart" button in the Wishlist page.', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'wl_remove',
			'type' => 'button_set',
			'title' => __('Remove Wishlist items added to Cart', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Remove the products from the wishlist if is been added to the Cart.', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'wl_facebook',
			'type' => 'button_set',
			'title' => __('Share on Facebook', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Share your Wishlist products on Facebook.', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'wl_twitter',
			'type' => 'button_set',
			'title' => __('Tweet on Twitter', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Tweet your Wishlist products on Twitter.', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'wl_pinterest',
			'type' => 'button_set',
			'title' => __('Pin on Pinterest', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Pin your Wishlist products on Pinterest.', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'wl_google',
			'type' => 'button_set',
			'title' => __('Share on Google+', 'aloom'), 
			'options' => array('1' => 'Enable','0' => 'Disable'),
			'desc' => __('Share your Wishlist products on Google+.', 'aloom'),
			'std' => '1'
		),
		array(
			'id' => 'wl_stitle',
			'type' => 'text',
			'title' => __('Socials title', 'aloom'),
			'desc' => __('Set Social title when sharing.', 'aloom'),
			'std' => 'My Wishlist on '.THEME_NAME.' Shop'
		),
		array(
			'id' => 'wl_stext',
			'type' => 'text',
			'title' => __('Socials text', 'aloom'),
			'desc' => __('Facebook, Twitter and Pinterest. Use %wishlist_url% where you want the URL of your wishlist to appear.', 'aloom'),
			'std' => ''
		),
		array(
			'id' => 'wl_simage',
			'type' => 'text',
			'title' => __('Socials image URL', 'aloom'),
			'desc' => __('Set socials image URL when sharing.', 'aloom'),
			'std' => ''
		)
	)

);



			
	$tabs = array();
			
	if (function_exists('wp_get_theme')){
		$theme_data = wp_get_theme();
		$theme_uri = $theme_data->get('ThemeURI');
		$description = $theme_data->get('Description');
		$author = $theme_data->get('Author');
		$version = $theme_data->get('Version');
		$tags = $theme_data->get('Tags');
	}else{
		$theme_data = wp_get_theme(trailingslashit(get_stylesheet_directory()).'style.css');
		$theme_uri = $theme_data['URI'];
		$description = $theme_data['Description'];
		$author = $theme_data['Author'];
		$version = $theme_data['Version'];
		$tags = $theme_data['Tags'];
	}	
	
	
	
	if(file_exists(trailingslashit(get_stylesheet_directory()).'README.html')){
		$tabs['theme_docs'] = array(
						'icon' => king_options_URL.'img/glyphicons/glyphicons_071_book.png',
						'title' => __('Documentation', 'aloom'),
						'content' => nl2br(devnExt::file( 'get', trailingslashit(get_stylesheet_directory()).'README.html'))
						);
	}//if

	global $king_options, $king;
	
	$king_options = new king_options($sections, $args, $tabs);
	$king->cfg = get_option( $args['opt_name'] );

}//function
add_action('init', 'setup_framework_options', 0);

/*
 * 
 * Custom function for the callback referenced above
 *
 */
function video_get_start($field, $value){
	
	switch( $field['id'] ){
		case 'inspector':
		  echo '<ifr'.'ame width="560" height="315" src="http://www.youtube.com/embed/rO8HYqUUbL8?vq=hd720&rel=0&start=76" frameborder="0" allowfullscreen></ifr'.'ame>';
		break;
		case 'grid':
			echo '<ifr'.'ame width="560" height="315" src="http://www.youtube.com/embed/rO8HYqUUbL8?vq=hd720&rel=0" frameborder="0" allowfullscreen></ifr'.'ame>';
		break;
	}

}//function

/*
 * 
 * Custom function for the callback validation referenced above
 *
 */
function validate_callback_function($field, $value, $existing_value){
	
	$error = false;
	$value =  'just testing';	
	$return['value'] = $value;
	if($error == true){
		$return['error'] = $field;
	}
	return $return;
	
}//function
?>